<?php
require_once(dirname(__FILE__).'/constants.php');
require_once(dirname(__FILE__).'/database.php');
require_once(dirname(__FILE__).'/session.php');


class Process {
	function Process() {
		global $session, $logger;

		if(!isset($_REQUEST['request_name'])) $_REQUEST['request_name'] = '';

		if ( isset($_REQUEST['proclogin']) ) $this->proclogin();
		elseif ( isset($_REQUEST['procregistration']) ) $this->procregistration();
		
		elseif( $_REQUEST['request_name'] == 'get_db_options' ) $this->proc_get_db_options();
		elseif( $_REQUEST['request_name'] == 'save_db_options' ) $this->proc_save_db_options();
		elseif( $_REQUEST['request_name'] == 'get_sip_ip_transport' ) $this->proc_get_sip_ip_transport();
		elseif( $_REQUEST['request_name'] == 'save_sip_ip_transport' ) $this->proc_save_sip_ip_transport();
		elseif( $_REQUEST['request_name'] == 'del_sip_ip_transport' ) $this->proc_del_sip_ip_transport();
		elseif( $_REQUEST['request_name'] == 'get_sip_accounts' ) $this->proc_get_sip_accounts();
		elseif( $_REQUEST['request_name'] == 'get_sip_account_types' ) $this->proc_get_sip_account_types();
		elseif( $_REQUEST['request_name'] == 'save_sip_account' ) $this->proc_save_sip_account();
		elseif( $_REQUEST['request_name'] == 'del_sip_account' ) $this->proc_del_sip_account();
		elseif( $_REQUEST['request_name'] == 'get_active_sessions' ) $this->proc_get_active_sessions();
		elseif( $_REQUEST['request_name'] == 'get_archive_sessions' ) $this->proc_get_archive_sessions();

















		elseif( $_REQUEST['request_name'] == 'get_common_param' ) $this->proc_get_common_param();

		elseif( $_REQUEST['request_name'] == 'emploee_add' ) $this->proc_emploee_add();
		elseif( $_REQUEST['request_name'] == 'emploee_edt' ) $this->proc_emploee_edt();
		elseif( $_REQUEST['request_name'] == 'emploee_del' ) $this->proc_emploee_del();
		elseif( $_REQUEST['request_name'] == 'get_office_group' ) $this->proc_get_office_group();
		elseif( $_REQUEST['request_name'] == 'get_graphs_list' ) $this->proc_get_graphs_list();
		elseif( $_REQUEST['request_name'] == 'get_synthez_list' ) $this->proc_get_synthez_list();
		elseif( $_REQUEST['request_name'] == 'get_role_list' ) $this->proc_get_role_list();
		elseif( $_REQUEST['request_name'] == 'emploee_info' ) $this->proc_emploee_info();
		elseif( $_REQUEST['request_name'] == 'emploee_params' ) $this->proc_emploee_params();
		elseif( $_REQUEST['request_name'] == 'get_emploee_group_list' ) $this->proc_get_emploee_group_list();
		
		elseif( $_REQUEST['request_name'] == 'do_upload_file' ) $this->proc_do_upload_file();

		elseif( $_REQUEST['request_name'] == 'emploee_group_add' ) $this->proc_emploee_group_add();
		elseif( $_REQUEST['request_name'] == 'emploee_group_edt' ) $this->proc_emploee_group_edt();
		elseif( $_REQUEST['request_name'] == 'emploee_group_del' ) $this->proc_emploee_group_del();
		elseif( $_REQUEST['request_name'] == 'emploee_group_params' ) $this->proc_emploee_group_params();
		elseif( $_REQUEST['request_name'] == 'group_employee_list' ) $this->proc_group_employee_list();
		elseif( $_REQUEST['request_name'] == 'get_employee_for_group' ) $this->proc_get_employee_for_group();
		elseif( $_REQUEST['request_name'] == 'employee_for_group_edt' ) $this->proc_employee_for_group_edt();
			
		elseif( $_REQUEST['request_name'] == 'get_cityfilial_list' ) $this->proc_get_cityfilial_list();
		elseif( $_REQUEST['request_name'] == 'get_citynumber_list' ) $this->proc_get_citynumber_list();
		elseif( $_REQUEST['request_name'] == 'do_office_number_add' ) $this->proc_do_office_number_add();
		elseif( $_REQUEST['request_name'] == 'do_office_number_del' ) $this->proc_do_office_number_del();
		elseif( $_REQUEST['request_name'] == 'do_office_number_edt' ) $this->proc_do_office_number_edt();

		elseif( $_REQUEST['request_name'] == 'get_office_number_list' ) $this->proc_get_office_number_list();
		elseif( $_REQUEST['request_name'] == 'get_user_group_list' ) $this->proc_get_user_group_list();
		elseif( $_REQUEST['request_name'] == 'get_number_timeout_list' ) $this->proc_get_number_timeout_list();
		elseif( $_REQUEST['request_name'] == 'get_voice_menu_list' ) $this->proc_get_voice_menu_list();

		elseif( $_REQUEST['request_name'] == 'do_office_sip_number_add' ) $this->proc_do_office_sip_number_add();
		elseif( $_REQUEST['request_name'] == 'office_number_param' ) $this->proc_office_number_param();
		elseif( $_REQUEST['request_name'] == 'check_number_existing' ) $this->proc_check_number_existing();
		
		elseif( $_REQUEST['request_name'] == 'camp_table_reload' ) $this->proc_camp_table_reload();
		elseif( $_REQUEST['request_name'] == 'do_camp_edt' ) $this->proc_do_camp_edt();
		elseif( $_REQUEST['request_name'] == 'do_camp_del' ) $this->proc_do_camp_del();
		elseif( $_REQUEST['request_name'] == 'get_camp_param' ) $this->proc_get_camp_param();
		elseif( $_REQUEST['request_name'] == 'channel_table_reload' ) $this->proc_channel_table_reload();
		elseif( $_REQUEST['request_name'] == 'get_channeltype_list' ) $this->proc_get_channeltype_list();
		elseif( $_REQUEST['request_name'] == 'get_promosegment_list' ) $this->proc_get_promosegment_list();
		elseif( $_REQUEST['request_name'] == 'get_channel_param' ) $this->proc_get_channel_param();
		elseif( $_REQUEST['request_name'] == 'get_channel_number' ) $this->proc_get_channel_number();
		elseif( $_REQUEST['request_name'] == 'do_channel_edt' ) $this->proc_do_channel_edt();
		elseif( $_REQUEST['request_name'] == 'do_channel_del' ) $this->proc_do_channel_del();

		elseif( $_REQUEST['request_name'] == 'get_stats_table' ) $this->proc_get_stats_table();
		elseif( $_REQUEST['request_name'] == 'get_stats_table_count' ) $this->proc_get_stats_table_count();

		elseif( $_REQUEST['request_name'] == 'get_kpi_table' ) $this->proc_get_kpi_table();
		elseif( $_REQUEST['request_name'] == 'get_promocamp_list' ) $this->proc_get_promocamp_list();
		elseif( $_REQUEST['request_name'] == 'get_roi_table' ) $this->proc_get_roi_table();

		elseif( $_REQUEST['request_name'] == 'get_partner_param' ) $this->proc_get_partner_param();
		elseif( $_REQUEST['request_name'] == 'get_timezone' ) $this->proc_get_timezone();
		elseif( $_REQUEST['request_name'] == 'set_timezone' ) $this->proc_set_timezone();
		
		elseif( $_REQUEST['request_name'] == 'set_amocrm_service' ) $this->proc_set_amocrm_service();
		elseif( $_REQUEST['request_name'] == 'get_amocrm_service' ) $this->proc_get_amocrm_service();

		elseif( $_REQUEST['request_name'] == 'user_sipaccount_freenumber' ) $this->proc_user_sipaccount_freenumber();

		elseif( $_REQUEST['request_name'] == 'graphic_add' ) $this->proc_graphic_add();
		elseif( $_REQUEST['request_name'] == 'graphic_edt' ) $this->proc_graphic_edt();
		elseif( $_REQUEST['request_name'] == 'graphic_del' ) $this->proc_graphic_del();
		elseif( $_REQUEST['request_name'] == 'graphs_params' ) $this->proc_graphs_params();

		elseif( $_REQUEST['request_name'] == 'get_office_account_info' ) $this->proc_get_office_account_info();
		

		
		elseif($session->logged_in)
			$this->proclogout();
		else
			header("Location: ../main.php");
		

	}

	// логин
	function proclogin() {
		//global $session, $database, $form, $logger;
		global $session, $database, $logger;
		//$logger->log("procLogin:post=".print_r($session->syssession, true));
		
		$txt_login = $_REQUEST['txt_login'];
		$txt_password = $_REQUEST['txt_password'];
		$txt_remember = 0;

		$res = $session->login($txt_login, $txt_password, $txt_remember);

		/*
		if($res){
			// log data about success authorization
			$database->logOfficeChange(CL_OF_UAC_LOGIN, $session->of_id, 0, "Успешная авторизация. Пользователь '".$session->user_name."' (id:".$session->user_id.")");
			$logger->log("process:login = success, user = {$_REQUEST['txt_login']}");
		} else {
			// log data about authorization error
			$database->logOfficeChange(CL_OF_UAC_LOGIN_FAIL, -1, 0, "Неуспешная попытка авторизации под пользователем '{$_REQUEST['txt_login']}'.");
			$logger->log("process:login = failed, user = {$_REQUEST['txt_login']}");
		}
		*/

		header("Location: ".$session->referrer);
	}

	// логаут
	function proclogout() {
		global $session, $database, $logger;

		$logger->log("user logout: user_id = ".$session->user_id);

		// changelog deathorization
		//$database->logOfficeChange(CL_OF_UAC_LOGOUT, $session->of_id, 0, "Разавторизация. Пользователь '".$session->user_name."' (id:".$session->user_id.")");

		$session->logout();
		header("Location: ../main.php");
	}



//----------------------------------------------------------------------------------------------------------------


	function proc_get_db_options() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select * from db_options;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'option_name' => $row['option_name'],
			'int_value' => $row['int_value'],
			'str_value' => $row['str_value'],
			'date_value' => $row['date_value'],
			'float_value' => $row['float_value'],
			'description' => $row['description'],
			'param_type' => $row['param_type'],
			'param_name' => $row['param_name']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}






//----------------------------------------------------------------------------------------------------------------










































	
	// регистрация нового кабинета
	function procregistration() {
		global $session, $database, $logger;

		//$logger->log("procLogin:post=".print_r($session->syssession, true));
		
		$txt_login = $_REQUEST['txt_login'];
		$txt_userfio = $_REQUEST['txt_userfio'];
		$txt_password = $_REQUEST['txt_password'];
		$txt_firmname = $_REQUEST['txt_firmname'];
		$txt_mail = $_REQUEST['txt_mail'];
		$txt_promocode = $_REQUEST['txt_promocode'];
		$txt_phone = $_REQUEST['txt_phone'];
		
		$q = <<<EOS
		execute procedure FM_OFFICE_REGISTRATION(
			:USER_NAME,
			:USER_FIO,
			:USER_PASSWORD,
			:FIRM_NAME,
			:USER_MAIL,
			:PROMOCODE,
			:USER_PHONE
		)		
EOS;

		//$logger->log($q.'  '.$txt_login.'  '.$txt_userfio.'  '.$txt_password.'  '.$txt_firmname.'  '.$txt_mail.'  '.$txt_promocode.'  '.$txt_phone);
		
		$q=$database->prepare($q);
		
		$q->bindValue(":USER_NAME",$txt_login);
		$q->bindValue(":USER_FIO",$txt_userfio);
		$q->bindValue(":USER_PASSWORD",$txt_password);
		$q->bindValue(":FIRM_NAME",$txt_firmname);
		$q->bindValue(":USER_MAIL",$txt_mail);
		$q->bindValue(":PROMOCODE",$txt_promocode);
		$q->bindValue(":USER_PHONE",$txt_phone);

		
		//$q->bindParam(":OFFICE_ID",$office_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":USER_ID",$user_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":DIALS_ID",$dials_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":EXT_NUMBER_ID",$ext_number_id,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":EMITTERKCID",$emitterkcid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":ACCOUNTID",$accountid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":SIP_ID",$sip_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);

		
		$q->execute();
		$res = $q->fetchAll();

		if( $res and $res[0]['office_id']>0 ){
			$office_id = $res[0]['office_id'];
			$logger->log("create office_id = ".$res[0]['office_id']);
			$session->registration_ok = true;
		}
		
		
	/*	
	$message = 'zzzzzzzzzzz'; 
	$message = mb_convert_encoding($message,'KOI8-R','UTF-8');
	$headers  = "Content-type: text/html; charset=KOI8-R \r\n";
	$headers .= "From: http://lk.carat-telecom.ru/ \r\n";
	$result = mail ( $txt_mail, 'Password Recovery', $message, $headers);
	
	$logger->log("z1 = ".$txt_mail);
	$logger->log("z2 = ".$message);
	$logger->log("z3 = ".$headers);
	$logger->log("mail_result = ".$result,"           zz = ".$txt_mail);
	*/	
		
		
		header("Location: ".$session->referrer);
	}
	
	
	
	
	
/*	
	// регистрация
	function procregistration() {
		global $session, $database, $logger;

		//$logger->log("procLogin:post=".print_r($session->syssession, true));
		
		$txt_login = $_REQUEST['txt_login'];
		$txt_userfio = $_REQUEST['txt_userfio'];
		$txt_password = $_REQUEST['txt_password'];
		$txt_firmname = $_REQUEST['txt_firmname'];
		$txt_mail = $_REQUEST['txt_mail'];
		$txt_promocode = $_REQUEST['txt_promocode'];
		$txt_phone = $_REQUEST['txt_phone'];
		
		$q = <<<EOS
		execute procedure FM_OFFICE_REGISTRATION(
			:USER_NAME,
			:USER_FIO,
			:USER_PASSWORD,
			:FIRM_NAME,
			:USER_MAIL,
			:PROMOCODE,
			:USER_PHONE
		)		
EOS;

		$logger->log($q.'  '.$txt_login.'  '.$txt_userfio.'  '.$txt_password.'  '.$txt_firmname.'  '.$txt_mail.'  '.$txt_promocode.'  '.$txt_phone);
		
		$q=$database->prepare($q);
		
		$q->bindValue(":USER_NAME",$txt_login);
		$q->bindValue(":USER_FIO",$txt_userfio);
		$q->bindValue(":USER_PASSWORD",$txt_password);
		$q->bindValue(":FIRM_NAME",$txt_firmname);
		$q->bindValue(":USER_MAIL",$txt_mail);
		$q->bindValue(":PROMOCODE",$txt_promocode);
		$q->bindValue(":USER_PHONE",$txt_phone);

		
		$q->bindParam(":OFFICE_ID",$office_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_ID",$user_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID",$dials_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":EXT_NUMBER_ID",$ext_number_id,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":EMITTERKCID",$emitterkcid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":ACCOUNTID",$accountid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":SIP_ID",$sip_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);

		
		$q->execute();
		$res = $q->fetchAll();

		$logger->log("ZZZZ  ".$res[0]['office_id']);

		if( $res and $res[0]['office_id']>0 ){
			$logger->log("create office_id = ".$res[0]['office_id']);
			$session->registration_ok = true;
		}
		
		header("Location: ".$session->referrer);
	}
*/
	
	
	
	// добавление сотрудника
	function proc_emploee_add() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;

		$txt_user_fio = $_REQUEST['txt_user_fio'];
		$txt_graphs_list = $_REQUEST['txt_graphs_list'];
		$txt_int_number = $_REQUEST['txt_int_number'];
		$txt_real_number = $_REQUEST['txt_real_number'];
		$txt_synthez_list = $_REQUEST['txt_synthez_list'];
		
		$txt_ext_number = $_REQUEST['txt_ext_number'];
		$txt_email = $_REQUEST['txt_email'];
		$txt_sip_server = $_REQUEST['txt_sip_server'];
		$txt_sip_login = $_REQUEST['txt_sip_login'];
		$txt_sip_pass = $_REQUEST['txt_sip_pass'];
		$txt_check_user = $_REQUEST['txt_check_user'];
		
		if( $txt_check_user ){
			$txt_role_list = $_REQUEST['txt_role_list'];
			$txt_user_name = !empty($_REQUEST['txt_user_name']) ? $_REQUEST['txt_user_name'] : 'guest';
			$txt_user_pass = $_REQUEST['txt_user_pass'];
		} else {
			$txt_role_list = null;
			$txt_user_name = 'guest';
			$txt_user_pass = null;
		}

		$employee = $_REQUEST['employee'];
		$user_groups = $_REQUEST['user_groups'];
		$file_name = $employee['photo_name'];
		$file_path = $employee['photo_path'];
		
	
		if( file_exists($file_path) ) {
			$f=fopen($file_path,"rb"); 
			$photo_content=fread($f,filesize($file_path));
			fclose($f);
			unlink($file_path);
		} else {
			//$photo_content = null;
			// если файла аватарки нет, сохраняем рисунок по-умолчанию 
			$file_path = '../../'.DEFAULT_AVATAR;
			$image_info = $this->get_image_info($file_path);
			$file_name = 'img_'.uniqid(mt_rand(1000000,9999999).'_',true).'.'.$image_info['extension'];
			//$file_name = uniqid(mt_rand(1000000,9999999).'_',true).'.png';
			$f=fopen($file_path,"rb"); 
			$photo_content=fread($f,filesize($file_path));
			fclose($f);
		}

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_ADD(
			:OF_ID,
			:USER_FIO,
			:USER_NAME,
			:USER_PASSWORD,
			:USER_ROLE,
			:INT_NUMBER,
			:EXT_NUMBER,
			:REAL_NUMBER,
			:USER_MAIL,
			:WAIT_ANSWER_PHRASE,
			:GRAPH_ID,
			:SIP_SERVER,
			:SIP_NAME,
			:SIP_SECRET,
			:SIPDEFAULT_ID,
			:USER_PHOTO_NAME,
			:USER_PHOTO_FILE,
			:USER_GROUPS
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":USER_FIO",$txt_user_fio);
		$q->bindValue(":USER_NAME",$txt_user_name);
		$q->bindValue(":USER_PASSWORD",$txt_user_pass);
		$q->bindValue(":USER_ROLE",$txt_role_list);
		$q->bindValue(":INT_NUMBER",$txt_int_number);
		$q->bindValue(":EXT_NUMBER",$txt_ext_number);
		$q->bindValue(":REAL_NUMBER",$txt_real_number);
		$q->bindValue(":USER_MAIL",$txt_email);
		$q->bindValue(":WAIT_ANSWER_PHRASE",$txt_synthez_list);
		$q->bindValue(":GRAPH_ID",$txt_graphs_list);
		$q->bindValue(":SIP_SERVER",$txt_sip_server);
		$q->bindValue(":SIP_NAME",$txt_sip_login);
		$q->bindValue(":SIP_SECRET",$txt_sip_pass);
		$q->bindValue(":SIPDEFAULT_ID",SIP_TEMPLATE_DEFAULT); // from constants.php
		$q->bindValue(":USER_PHOTO_NAME",$file_name);
		$q->bindValue(":USER_PHOTO_FILE",$photo_content, PDO::PARAM_LOB);
		$q->bindValue(":USER_GROUPS",$user_groups);
		
		$q->bindParam(":USER_ID",$user_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID",$dials_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":EXT_NUMBER_ID",$ext_number_id,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":EMITTERKCID",$emitterkcid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":ACCOUNTID",$accountid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":SIP_ID",$sip_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	// информация о сотруднике
	function proc_emploee_info() {
		global $database, $logger;

		$txt_user_id = $_REQUEST['txt_user_id'];

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_INFO(	:USER_ID );
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":USER_ID",$txt_user_id);
		
		/*$q->bindParam(":OF_ID",$of_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_FIO",$user_fio,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_NAME",$user_name,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_PASSWORD",$user_password,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_ROLE",$user_role,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_MAIL",$user_mail,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":GROUP_ID",$group_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_PHOTO_NAME",$user_photo_name,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":USER_PHOTO_FILE",$user_photo_file,PDO::PARAM_LOB|PDO::PARAM_INPUT_OUTPUT);*/
		//$q->bindColumn(":USER_PHOTO_FILE",$user_photo_file,PDO::PARAM_LOB|PDO::PARAM_INPUT_OUTPUT);

		$q->execute();
		$result = $q->fetchAll();

		$fname = !empty($result[0]['user_photo_name']) ? '../../'.AVATAR_PATH.$result[0]['user_photo_name'] : '';
		//$logger->log("fname = ".$fname, PEAR_LOG_DEBUG);
		//$logger->log("ffile = ".$result[0]['user_photo_file'], PEAR_LOG_DEBUG);
		$fcontent = $result[0]['user_photo_file'];
		if(!empty($fname)){
			$f = fopen($fname,"wb"); 
			fwrite($f,$fcontent);
			fclose($f);
		}

		//$res = array('result' => $result);
		//$res = array('user_fio' => $result[0]['$user_fio']);
		$res = array(
			'user_fio' => $result[0]['user_fio'],
			'group_name' => $result[0]['group_name'],
			'graph_name' => $result[0]['graph_name'],
			'int_number' => $result[0]['internal_number'],
			'real_number' => $result[0]['real_number'],
			'ext_number' => $result[0]['external_number'],
			'synthez_description' => $result[0]['synthez_description'],
			
			'user_name' => $result[0]['user_name'],
			'user_mail' => $result[0]['user_mail'],
			'role_name' => $result[0]['role_name'],

			'sip_name' => $result[0]['sip_name'],
			'sip_server' => $result[0]['sip_server'],
  
			'user_photo_name' => $fname
		);

		echo json_encode($res);
	}


	// заполнение параметров сотрудника на странице редактирования
	function proc_emploee_params() {
		global $database, $session, $logger;

		$txt_user_id = $_REQUEST['txt_user_id'];
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_PARAMS( :OF_ID, :USER_ID );
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":USER_ID",$txt_user_id);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$result = $q->fetchAll();

		$fname = !empty($result[0]['user_photo_name']) ? '../../'.AVATAR_PATH.$result[0]['user_photo_name'] : '';
		//$logger->log("fname = ".$fname, PEAR_LOG_DEBUG);
		//$logger->log("ffile = ".$result[0]['user_photo_file'], PEAR_LOG_DEBUG);
		$fcontent = $result[0]['user_photo_file'];
		if(!empty($fname)){
			$f = fopen($fname,"wb"); 
			fwrite($f,$fcontent);
			fclose($f);
		}

		$res = array(
			'user_fio' => $result[0]['user_fio'],
			'group_id' => $result[0]['group_id'],
			'graph_id' => $result[0]['graph_id'],
			'group_name' => $result[0]['group_name'],
			'graph_name' => $result[0]['graph_name'],
			'int_number' => $result[0]['int_number'],
			'real_number' => $result[0]['real_number'],
			'ext_number' => $result[0]['ext_number'],
			'synthez_id' => $result[0]['synthez_id'],
			'user_mail' => $result[0]['user_mail'],

			'sip_name' => $result[0]['sip_name'],
			'sip_secret' => $result[0]['sip_secret'],
			'sip_server' => $result[0]['sip_server'],
			'sip_id' => $result[0]['sip_id'],

			'user_name' => $result[0]['user_name'],
			'user_password' => $result[0]['user_password'],
			'role_id' => $result[0]['role_id'],
			
			'user_photo_name' => $result[0]['user_photo_name'],
			'user_photo_path' => $fname
		);

		echo json_encode($res);
	}


	// редактирование сотрудника
	function proc_emploee_edt() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;

		$txt_user_id = $_REQUEST['txt_user_id'];
		$txt_sip_id = $_REQUEST['txt_sip_id'];
		
		$txt_user_fio = $_REQUEST['txt_user_fio'];
		$txt_graphs_list = $_REQUEST['txt_graphs_list'];
		$txt_int_number = $_REQUEST['txt_int_number'];
		$txt_real_number = $_REQUEST['txt_real_number'];
		$txt_synthez_list = $_REQUEST['txt_synthez_list'];
		
		$txt_ext_number = $_REQUEST['txt_ext_number'];
		$txt_email = $_REQUEST['txt_email'];
		$txt_sip_server = $_REQUEST['txt_sip_server'];
		$txt_sip_login = $_REQUEST['txt_sip_login'];
		$txt_sip_pass = $_REQUEST['txt_sip_pass'];
		$txt_check_user = $_REQUEST['txt_check_user'];
		
		if( $txt_check_user ){
			$txt_role_list = $_REQUEST['txt_role_list'];
			$txt_user_name = !empty($_REQUEST['txt_user_name']) ? $_REQUEST['txt_user_name'] : 'guest';
			$txt_user_pass = $_REQUEST['txt_user_pass'];
		} else {
			$txt_role_list = null;
			$txt_user_name = 'guest';
			$txt_user_pass = null;
		}

		$employee = $_REQUEST['employee'];
		$user_groups = $_REQUEST['user_groups'];
		$file_name = $employee['photo_name'];
		$file_path = $employee['photo_path'];

		if( file_exists($file_path) ) {
			//$photo_content=file_get_contents($file_path);
			$fh=fopen($file_path,"rb");
			$file_size = filesize($file_path);
			$photo_content=fread($fh,$file_size);
			fclose($fh);
			//unlink($file_path);
		} else {
			//$photo_content = null;
			// если файла аватарки нет, сохраняем рисунок по-умолчанию 
			$file_path = '../../'.DEFAULT_AVATAR;
			$image_info = $this->get_image_info($file_path);
			$file_name = 'img_'.uniqid(mt_rand(1000000,9999999).'_',true).'.'.$image_info['extension'];
			//$file_name = uniqid(mt_rand(1000000,9999999).'_',true).'.png';
			$f=fopen($file_path,"rb"); 
			$photo_content=fread($f,filesize($file_path));
			fclose($f);
		}
		
		$q = <<<EOS
		execute procedure FM_EMPLOYEE_EDT(
			:USER_ID,
			:USER_FIO,
			:USER_NAME,
			:USER_PASSWORD,
			:USER_ROLE,
			:INT_NUMBER,
			:EXT_NUMBER,
			:REAL_NUMBER,
			:USER_MAIL,
			:WAIT_ANSWER_PHRASE,
			:GRAPH_ID,
			:SIP_SERVER,
			:SIP_NAME,
			:SIP_SECRET,
			:SIPDEFAULT_ID,
			:USER_PHOTO_NAME,
			:USER_PHOTO_FILE,
			:USER_GROUPS
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":USER_ID",$txt_user_id);
		$q->bindValue(":USER_FIO",$txt_user_fio);
		$q->bindValue(":USER_NAME",$txt_user_name);
		$q->bindValue(":USER_PASSWORD",$txt_user_pass);
		$q->bindValue(":USER_ROLE",$txt_role_list);
		$q->bindValue(":INT_NUMBER",$txt_int_number);
		$q->bindValue(":EXT_NUMBER",$txt_ext_number);
		$q->bindValue(":REAL_NUMBER",$txt_real_number);
		$q->bindValue(":USER_MAIL",$txt_email);
		$q->bindValue(":WAIT_ANSWER_PHRASE",$txt_synthez_list);
		$q->bindValue(":GRAPH_ID",$txt_graphs_list);
		$q->bindValue(":SIP_SERVER",$txt_sip_server);
		$q->bindValue(":SIP_NAME",$txt_sip_login);
		$q->bindValue(":SIP_SECRET",$txt_sip_pass);
		$q->bindValue(":SIPDEFAULT_ID",SIP_TEMPLATE_DEFAULT); // from constants.php
		$q->bindValue(":USER_PHOTO_NAME",$file_name);
		$q->bindParam(":USER_PHOTO_FILE", $photo_content,PDO::PARAM_LOB, $file_size);
		$q->bindValue(":USER_GROUPS",$user_groups);
		
		//$q->bindParam(":OF_ID",$of_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		//$q->bindParam(":SIP_ID",$sip_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		
		$q->bindColumn(":OF_ID",$of_id);
		$q->bindColumn(":SIP_ID",$sip_id);
	
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
	
	
		// редактирование сотрудника
	function __proc_emploee_edt() {
		global $database, $logger;
		
		$txt_user_fio = $_REQUEST['txt_user_fio'];
		$txt_user_id = $_REQUEST['txt_user_id'];

		$q = <<<EOS
		update tb_office_users set
		user_fio = ?
		where 
		user_id = ?
EOS;
		$q = $database->prepare($q);
		$res = $database->execute_res($q,array($txt_user_fio,$txt_user_id));
		
		
		$res = array('txt_user_fio' => $txt_user_fio);
		echo json_encode($res);
	}

		// удаление сотрудника
	function proc_emploee_del() {
		global $database, $logger;
		
		$user_id = $_REQUEST['user_id'];

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_DEL(?)
EOS;
		$q = $database->prepare($q);
		$res = $database->execute($q,array($user_id));
		
		$res = array('res' => 'ok');
		echo json_encode($res);
	}	
	
	// группы сотрудников ---------------------------------------------------------------------------
	function proc_get_office_group(){
		global $database, $logger;
	
		$ofid = $_REQUEST['ofid'];
	
		$q = <<<EOS
		select
		group_id,
		group_name
		from tb_office_group
		where of_id = ?;
EOS;
		$q = $database->prepare($q);
		$res = $database->execute_res($q,array($ofid));

		
		foreach($res as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'group_id' => $row['group_id'],
				'group_name' => $row['group_name']
			);
			
			//$logger->log('group_name = '.$tabrow[$key]['group_name'].'   '.'group_id = '.$tabrow[$key]['group_id'], PEAR_LOG_DEBUG);
			//if(empty($res)){ $tabrow[0] = array('',''); }
		}
		if(empty($res)){ $tabrow[0] = array('','');	}
		$res = array('data' => $tabrow );
	
		echo json_encode($res);
	}
	
	
	// проверяем и перемещаем загружаемый файл в каталог /content/img/tmp
	function proc_do_upload_file(){
	global $database, $logger;

		$file = $_FILES['avatar'];

		//$im = new Imagick($filepath);
		//$im->thumbnailImage(200, null);		
		
		//$filepath = $uploadpath . basename($file['name']);
		//if( ! is_dir( $uploadpath ) ) mkdir( $uploadpath, 0777 );    
		/*$files = array();
		foreach( $_FILES as $file ){
			if( move_uploaded_file( $file['tmp_name'], $uploadpath . basename($file['name']) ) ){
				$files[] = realpath( $uploadpath . $file['name'] );
			}
		}*/

		$valid_extensions = array('gif', 'jpg', 'png');
		if(!$image_info = $this->get_image_info($file['tmp_name']) or !in_array($image_info['extension'], $valid_extensions))
		{ die('this file is not a picture'); } 
		else {
			$uploadpath = '../../'.AVATAR_PATH;
			$filename = uniqid(mt_rand(1000000,9999999).'_',true).'.'.$image_info['extension'];
			$filepath = $uploadpath . $filename;
			if(!@move_uploaded_file($file['tmp_name'], $filepath)) { 
				$logger->log('error: move uploaded file error', PEAR_LOG_DEBUG);
				die('move uploaded file error'); 
			} else {
				$filename = 'img_'.$filename;
				$this->image_resize($filepath, $uploadpath.$filename, 80, 80);
				unlink($filepath);
				$filepath = $uploadpath.$filename;
			}
		}		
		
		$res = array('res'=>'ok', 'filepath'=>$filepath, 'filename'=>$filename);
		echo json_encode($res);
	}	



	// Функция для определения параметров изображения
	// Возвращает массив параметров если файл изображение и FALSE при ошибке
	function get_image_info($file = NULL){
		if(!is_file($file)) return false;
		if(!$data = getimagesize($file) or !$filesize = filesize($file)) return false;
		/*$extensions = array(1 => 'gif',     2 => 'jpg',
							3 => 'png',     4 => 'swf',
							5 => 'psd',     6 => 'bmp',
							7 => 'tiff',    8 => 'tiff',
							9 => 'jpc',     10 => 'jp2',
							11 => 'jpx',    12 => 'jb2',
							13 => 'swc',    14 => 'iff',
							15 => 'wbmp',   16 => 'xbmp');*/
		$extensions = array(1 => 'gif', 2 => 'jpg', 3 => 'png');
		$result = array('width'     =>  $data[0],
						'height'    =>  $data[1],
						'extension' =>  $extensions[$data[2]],
						'size'      =>  $filesize,
						'mime'      =>  $data['mime']);
		return $result;
	}	

	// ресайзинг изображения (защита от внедрения вредоносного кода)
	function image_resize($img_file, $target_file, $width, $height)	{
	
		if(!file_exists($img_file)) return false;
	 
		if(!$source_im_info = @getimagesize($img_file)) return false;
	 
		$valid_im_types = array(1 => 'gif', 2 => 'jpeg', 3 => 'png');
	 
		if(!array_key_exists($source_im_info[2], $valid_im_types)) return false;
	 
		$img_open_func = 'imagecreatefrom'.$valid_im_types[$source_im_info[2]];
	 
		$source_im = $img_open_func($img_file);
	 
		$result_im = imagecreatetruecolor($width, $height);
	 
		if(!@imagecopyresampled($result_im, $source_im, 0, 0, 0, 0, $width, $height, $source_im_info[0], $source_im_info[1])) return false;
	 
		$img_close_func = 'image'.$valid_im_types[$source_im_info[2]];
	 
		if(!$img_close_func($result_im, $target_file)) return false;
	 
		imagedestroy($source_im);
	 
		imagedestroy($result_im);
	 
		return true;
	}
	
	// график работы
	function proc_get_graphs_list(){
		global $session, $database, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select
		graph_id,
		graph_name
		from tb_graph_list
		where of_id = :OF_ID;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$res = $q->fetchAll();

		foreach ($res as $key => $row) {
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'graph_id' => $row['graph_id'],
				'graph_name' => $row['graph_name']
			);
		}	
		if(!$res) { $tabrow[0] = array('',''); }
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}

	
	
	// мелодии - список
	function proc_get_synthez_list(){
		global $session, $database, $logger;
	
		$ofid = (int)$session->of_id;
	
		$q = <<<EOS
		select
		synthez_id,
		menu_id,
		synthez_place,
		synthez_description
		from fm_office_synthez_list(?);
EOS;
		$q = $database->prepare($q);
		$res = $database->execute_res($q,array($ofid));

		
		foreach($res as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'synthez_id' => $row['synthez_id'],
				'menu_id' => $row['menu_id'],
				'synthez_place' => $row['synthez_place'],
				'synthez_description' => $row['synthez_description']
			);
		}
		if(empty($res)){ $tabrow[0] = array('','','','');	}
		$res = array('data' => $tabrow );
	
		echo json_encode($res);
	}


	// роли пользователей - список
	function proc_get_role_list(){
		global $session, $database, $logger;
	
		$ofid = (int)$session->of_id;
	
		$q = <<<EOS
		select 
		v2.role_id, 
		v2.role_name
		from
		tb_officerole v1 inner join tb_userroles v2 on v1.role_id = v2.role_id
		where v1.role_access = 1 and v1.of_id = ?;
EOS;
		$q = $database->prepare($q);
		$res = $database->execute_res($q,array($ofid));

		
		foreach($res as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'role_id' => $row['role_id'],
				'role_name' => $row['role_name']
			);
		}
		if(empty($res)){ $tabrow[0] = array('','');	}
		$res = array('data' => $tabrow );
	
		echo json_encode($res);
	}
	
	
	// добавление группы сотрудников
	function proc_emploee_group_add() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;

		$txt_group_name = $_REQUEST['txt_group_name'];
		$txt_real_number = $_REQUEST['txt_real_number'];
		$txt_synthez_list = $_REQUEST['txt_synthez_list'];
		$txt_int_number = $_REQUEST['txt_int_number'];
		$txt_dial_mode = $_REQUEST['txt_dial_mode'];
		
		$q = <<<EOS
		execute procedure FM_EMPLOYEE_GROUP_ADD(
			:OF_ID,
			:GROUP_NAME,
			:TRANSLATE_REAL_AON,
			:WAIT_ANSWER_PHRASE,
			:INT_NUMBER,
			:DIAL_MODE
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":GROUP_NAME",$txt_group_name);
		$q->bindValue(":TRANSLATE_REAL_AON",$txt_real_number);
		$q->bindValue(":WAIT_ANSWER_PHRASE",$txt_synthez_list);
		$q->bindValue(":INT_NUMBER",$txt_int_number);
		$q->bindValue(":DIAL_MODE",$txt_dial_mode);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
	
	// удаление группы
	function proc_emploee_group_del() {
		global $database, $logger;
		
		$group_id = $_REQUEST['group_id'];

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_GROUP_DEL(?)
EOS;
		$q = $database->prepare($q);
		$res = $database->execute($q,array($group_id));
		
		$res = array('res' => 'ok');
		echo json_encode($res);
	}	
	
	
	// параметры группы
	function proc_emploee_group_params() {
		global $database, $logger;

		$txt_group_id = $_REQUEST['txt_group_id'];

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_GROUP_PARAMS( :GROUP_ID );
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":GROUP_ID",$txt_group_id);

		$q->execute();
		$q->bindParam(":OF_ID",$of_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":GROUP_NAME",$group_name,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":TRANSLATE_REAL_AON",$translate_real_aon,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":WAIT_ANSWER_PHRASE",$wait_answer_phrase,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":INT_NUMBER",$int_number,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":INTERNAL_NUMBER_ID",$internal_number_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIAL_MODE",$dial_mode,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID",$dials_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":SYNTHEZ_ID",$synthez_id,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":MENU_ID",$menu_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":SYNTHEZ_PLACE",$synthez_place,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":SYNTHEZ_DESCRIPTION",$synthez_description,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);

		$result = $q->fetchAll();

		$res = array(
			'of_id' => $result[0]['of_id'],
			'group_name' => $result[0]['group_name'],
			'translate_real_aon' => $result[0]['translate_real_aon'],
			'wait_answer_phrase' => $result[0]['wait_answer_phrase'],
			'int_number' => $result[0]['int_number'],
			'internal_number_id' => $result[0]['internal_number_id'],
			'dial_mode' => $result[0]['dial_mode'],
			'dials_id' => $result[0]['dials_id'],
			'synthez_id' => $result[0]['synthez_id'],
			'menu_id' => $result[0]['menu_id'],
			'synthez_place' => $result[0]['synthez_place'],
			'synthez_description' => $result[0]['synthez_description']
		);
		//$res = array('z'=>'');

		echo json_encode($res);
	}
	

	// редактирование параметров группы
	function proc_emploee_group_edt() {
		global $database, $session, $logger;
	
		//$ofid = 8;
		$ofid = (int)$session->of_id;

		$txt_group_id = $_REQUEST['txt_group_id'];
		$txt_group_name = $_REQUEST['txt_group_name'];
		$txt_real_number = $_REQUEST['txt_real_number'];
		$txt_synthez_list = $_REQUEST['txt_synthez_list'];
		$txt_int_number = $_REQUEST['txt_int_number'];
		$txt_dial_mode = $_REQUEST['txt_dial_mode'];

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_GROUP_EDT(
		:GROUP_ID,
		:GROUP_NAME,
		:TRANSLATE_REAL_AON,
		:WAIT_ANSWER_PHRASE,
		:INT_NUMBER,
		:DIAL_MODE
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":GROUP_ID",$txt_group_id);
		$q->bindValue(":GROUP_NAME",$txt_group_name);
		$q->bindValue(":TRANSLATE_REAL_AON",$txt_real_number);
		$q->bindValue(":WAIT_ANSWER_PHRASE",$txt_synthez_list);
		$q->bindValue(":INT_NUMBER",$txt_int_number);
		$q->bindValue(":DIAL_MODE",$txt_dial_mode);
		
		$q->bindColumn(":OF_ID",$of_id);
	
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	// формирование списка сотрудников группы с извлечением аватарок
	function proc_group_employee_list() {
		global $database, $logger;

		$txt_group_id = $_REQUEST['txt_group_id'];

		$q = <<<EOS
		select 
		USER_ID,
		USER_FIO,
		USER_PHOTO_NAME,
		USER_PHOTO_FILE
		from tb_office_users where group_id = :GROUP_ID;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":GROUP_ID",$txt_group_id);

		$q->execute();
		$result = $q->fetchAll();

		foreach ($result as $key => $row) {
			$fname = !empty($row['user_photo_name']) ? '../../'.AVATAR_PATH.$row['user_photo_name'] : '';
			$fcontent = $row['user_photo_file'];
			if(!empty($fname)){
				$f = fopen($fname,"wb"); 
				fwrite($f,$fcontent);
				fclose($f);
			}

			$res[$key] = array(
				'user_id' => $row['user_id'],
				'user_fio' => $row['user_fio'],
				'user_photo_name' => $fname
			);

		}		

		echo json_encode($res);
	}
	
/*	
	// города
	function proc_get_cityfilial_list(){
		global $logger;
	
		$q = <<<EOS
		select 
		cityfilial_id, 
		cityfilial
		from
		tbcityfilial;
EOS;
		$q = $database_tar->prepare($q);
		$q->execute();
		$res = $q->fetchAll();

		foreach($res as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'cityfilial_id' => $row['cityfilial_id'],
				'cityfilial' => $row['cityfilial']
			);
		}
		if(empty($res)){ $tabrow[0] = array('cityfilial_id' => '', 'cityfilial' => ''); }
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}
	
	// номерная емкость коммутатора
	function proc_get_citynumber_list(){
		global $database_tar, $logger;
	
		$txt_city_select = $_REQUEST['txt_city_select'];

		$q = <<<EOS
		select 
		v1.citynumber_id, 
		v1.citynumber,
		coalesce(v1.connectioncost,0) as connectioncost,
		coalesce(v1.abonplata,0) as abonplata
		from
		tbcitynumber v1 left join tbphones v2 on v1.citynumber = v2.numbera
		where v1.cityfilial_id = :CITY_ID and v2.numbera is null;
EOS;


		$q = $database_tar->prepare($q);
		$q->bindValue(":CITY_ID",$txt_city_select);
		
		$q->execute();
		$res = $q->fetchAll();

		foreach($res as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'citynumber_id' => $row['citynumber_id'],
				'citynumber' => $row['citynumber'],
				'connectioncost' => $row['connectioncost'],
				'abonplata' => $row['abonplata']
			);
		}
		if(empty($res)){ $tabrow[0] = array('citynumber_id' => '', 'citynumber' => ''); }
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}


	// подключение городского номера
	function proc_do_office_number_add() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;

		$txt_number_select = $_REQUEST['txt_number_select'];
		$txt_number_select_concost = $_REQUEST['txt_number_select_concost'];
		$txt_number_select_abon = $_REQUEST['txt_number_select_abon'];
		
		$q = <<<EOS
		execute procedure FM_OFFICE_NUMBER_ADD(
			:OF_ID,
			:OF_NUMBER,
			:CONNECTIONCOST,
			:ABONPLATA
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":OF_NUMBER",$txt_number_select);
		$q->bindValue(":CONNECTIONCOST",$txt_number_select_concost);
		$q->bindValue(":ABONPLATA",$txt_number_select_abon);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
*/	
	
	// телефония - номера
	function proc_get_office_number_list() {
		global $database, $logger, $session;

		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select * from FM_OFFICE_NUMBER_LIST(:OF_ID);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			//$param = "'".implode("|",$row)."'";
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'of_number_id' => $row['of_number_id'],
				'of_number' => $row['of_number'],
				'number_type_id' => $row['number_type_id'],
				'dials_id_1' => $row['dials_id_1'],
				'dials_id_2' => $row['dials_id_2'],
				'dials_id_3' => $row['dials_id_3'],
				'number_timeout_id' => $row['number_timeout_id'],
				'number_email' => $row['number_email'],
				'dials_name_1' => $row['dials_name_1'],
				'dials_name_2' => $row['dials_name_2'],
				'dials_name_3' => $row['dials_name_3'],
				'param' => $param

			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','','','','','','','','');	}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}


	// телефония - удаление номера
	function proc_do_office_number_del() {
		global $session, $database, $logger;

		$numid = $_REQUEST['numid'];
		
		$q = <<<EOS
		execute procedure FM_OFFICE_NUMBER_DEL(:OF_NUMBER_ID);		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_NUMBER_ID",$numid);
		
		$q->execute();
		$res = array('result' => 'ok');

		echo json_encode($res);
	}

/*
	// телефония - редактирование номеров
	function proc_do_office_number_edt() {
		global $database, $logger;

		$ofid = 8;
		
		$row_param = $_REQUEST['row_param'];
		//$logger->log($row_param, PEAR_LOG_DEBUG);
		$row_param = json_decode($row_param, true);
		//$logger->log($row_param[0]['number_email'], PEAR_LOG_DEBUG);

		$row_id = null;
		$dials_id_1 = null;
		$dials_id_2 = null;
		$dials_id_3 = null;
		$number_timeout_id = null;
		$number_email = null;

		$q = <<<EOS
		execute procedure FM_OFFICE_NUMBER_EDT(:ROW_ID, :DIALS_ID_1, :DIALS_ID_2, :DIALS_ID_3, :NUMBER_TIMEOUT_ID, :NUMBER_EMAIL);
EOS;
		$q=$database->prepare($q);
		$q->bindParam(":ROW_ID",$row_id);
		$q->bindParam(":DIALS_ID_1",$dials_id_1);
		$q->bindParam(":DIALS_ID_2",$dials_id_2);
		$q->bindParam(":DIALS_ID_3",$dials_id_3);
		$q->bindParam(":NUMBER_TIMEOUT_ID",$number_timeout_id);
		$q->bindParam(":NUMBER_EMAIL",$number_email);
			
		foreach($row_param as $key=>$row){
			
			$row_id = $row['row_id'];
			$dials_id_1 = $row['dials_id_1'];
			$dials_id_2 = $row['dials_id_2'];
			$dials_id_3 = $row['dials_id_3'];
			$number_timeout_id = $row['number_timeout_id'];
			$number_email = $row['number_email'];

			$q->execute();
		}

		$res = array('result' => 'ok');
		echo json_encode($res);
	}
*/
	// телефония - редактирование номера
	function proc_do_office_number_edt() {
		global $session, $database, $logger;

		$ofid = $session->of_id;
		
		$row_param = $_REQUEST['row_param'];
		//$logger->log($row_param, PEAR_LOG_DEBUG);
		$row_param = json_decode($row_param, true);
		//$logger->log($row_param[0]['number_email'], PEAR_LOG_DEBUG);

		$of_number_id = null;
		$dials_id_1 = null;
		$dials_id_2 = null;
		$dials_id_3 = null;
		$number_timeout_id = null;
		$number_email = null;
		$voice_menu_id = null;

		$q = <<<EOS
		execute procedure FM_OFFICE_NUMBER_EDT(:OF_NUMBER_ID, :DIALS_ID_1, :DIALS_ID_2, :DIALS_ID_3, :NUMBER_TIMEOUT_ID, :NUMBER_EMAIL, :VOICE_MENU_ID);
EOS;
		$q=$database->prepare($q);
		$q->bindParam(":OF_NUMBER_ID",$of_number_id);
		$q->bindParam(":DIALS_ID_1",$dials_id_1);
		$q->bindParam(":DIALS_ID_2",$dials_id_2);
		$q->bindParam(":DIALS_ID_3",$dials_id_3);
		$q->bindParam(":NUMBER_TIMEOUT_ID",$number_timeout_id);
		$q->bindParam(":NUMBER_EMAIL",$number_email);
		$q->bindParam(":VOICE_MENU_ID",$voice_menu_id);
		
			
		foreach($row_param as $key=>$row){
			
			$of_number_id = $row['of_number_id'];
			$dials_id_1 = $row['dials_id_1'];
			$dials_id_2 = $row['dials_id_2'];
			$dials_id_3 = $row['dials_id_3'];
			$number_timeout_id = $row['number_timeout_id'];
			$number_email = $row['number_email'];
			$voice_menu_id = $row['voice_menu_id'];

			$q->execute();
		}

		$res = array('result' => 'ok');
		echo json_encode($res);
	}

	
	// абоненты офиса
	function proc_get_user_group_list(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select * from FM_USERS_AND_GROUPS_LIST(:OF_ID);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'dials_id' => $row['dials_id'],
				'abonent_id' => $row['abonent_id'],
				'abonent_name' => $row['abonent_name'],
				'user_name' => $row['user_name'],
				'abonent_set' => $row['abonent_set'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','');	}
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}


	// задержка выбора (формирование списка options )
	function proc_get_number_timeout_list(){
		global $database, $logger, $session;
	
		//$ofid = 8;
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select null as number_timeout_id, '10, 15, 20 сек' as number_timeout from rdb\$database
		union all
		select number_timeout_id,number_timeout from TB_NUMBER_TIMEOUT;
EOS;
		$q=$database->prepare($q);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'number_timeout_id' => $row['number_timeout_id'],
				'number_timeout' => $row['number_timeout'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','');	}
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}


	// голосовое меню (формирование списка options )
	function proc_get_voice_menu_list(){
		global $database, $logger, $session;
	
		//$ofid = 8;
		$ofid = (int)$session->of_id;

/*		$q = <<<EOS
		select null as menu_id, null as item_id, 'Не выбрано' as item_name from rdb\$database
		union all
		select menu_id, item_id,item_name from FM_OFFICE_VOICE_MENU(:OF_ID);
EOS;*/
		$q = <<<EOS
		select menu_id, item_id,item_name from FM_OFFICE_VOICE_MENU(:OF_ID);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'menu_id' => $row['menu_id'],
				'item_id' => $row['item_id'],
				'item_name' => $row['item_name'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','');	}
		$res = array('data' => $tabrow );
		
//		$res = array('data' => '' );

		echo json_encode($res);
	}

	
	// подключение sip-номера
	function proc_do_office_sip_number_add() {
		global $database, $session, $logger;

		$ofid = (int)$session->of_id;

		$txt_sip_name = $_REQUEST['txt_sip_name'];
		$txt_sip_username = $_REQUEST['txt_sip_username'];
		$txt_sip_secret = $_REQUEST['txt_sip_secret'];
		$txt_sip_server = $_REQUEST['txt_sip_server'];
		
		$q = <<<EOS
		execute procedure FM_OFFICE_SIP_NUMBER_ADD(
			:OF_ID,
			:SIP_SERVER,
			:SIP_NAME,
			:SIP_SECRET,
			:SIP_USERNAME,
			:SIPDEFAULT_ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		
		$q->bindValue(":SIP_NAME",$txt_sip_name);
		$q->bindValue(":SIP_USERNAME",$txt_sip_username);
		$q->bindValue(":SIP_SECRET",$txt_sip_secret);
		$q->bindValue(":SIP_SERVER",$txt_sip_server);
		$q->bindValue(":SIPDEFAULT_ID",SIP_TEMPLATE_DEFAULT);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	// параметры номера офиса
	function proc_office_number_param() {
		global $session, $database, $logger;

		$of_id = $session->of_id;
		$txt_number_id = $_REQUEST['txt_number_id'];

		$q = <<<EOS
		execute procedure FM_OFFICE_NUMBER_PARAM( :OF_ID,:OF_NUMBER_ID  );
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$of_id);
		$q->bindValue(":OF_NUMBER_ID",$txt_number_id);

		$q->execute();
		$q->bindParam(":OF_NUMBER",$of_number,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":NUMBER_TYPE_ID",$number_type_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID_1",$dials_id_1,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID_2",$dials_id_2,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID_3",$dials_id_3,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":NUMBER_TIMEOUT_ID",$number_timeout_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":NUMBER_EMAIL",$number_email,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_NAME_1",$dials_name_1,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_NAME_2",$dials_name_2,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_NAME_3",$dials_name_3,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":NUMBER_TIMEOUT",$number_timeout,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":VOICE_MENU_ID",$voice_menu_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		
		$result = $q->fetchAll();

		$res = array(
			'of_number' => $result[0]['of_number'],
			'number_type_id' => $result[0]['number_type_id'],
			'dials_id_1' => $result[0]['dials_id_1'],
			'dials_id_2' => $result[0]['dials_id_2'],
			'dials_id_3' => $result[0]['dials_id_3'],
			'number_timeout_id' => $result[0]['number_timeout_id'],
			'number_email' => $result[0]['number_email'],
			'dials_name_1' => $result[0]['dials_name_1'],
			'dials_name_2' => $result[0]['dials_name_2'],
			'dials_name_3' => $result[0]['dials_name_3'],
			'number_timeout' => $result[0]['number_timeout'],
			'voice_menu_id' => $result[0]['voice_menu_id']
		);

		//$res = array('z'=>$of_id);

		echo json_encode($res);
	}
	
	
	// проверка на существование номера (на занятость)
	function proc_check_number_existing(){
		global $database, $logger;
	
		$num = $_REQUEST['num'];
		$server = $_REQUEST['server'];

		$q = <<<EOS
		select res from FM_CHECK_NUMBER_EXIST(:OF_NUMBER,:SIP_SERVER);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_NUMBER",$num);
		$q->bindValue(":SIP_SERVER",$server);
		$q->execute();
		$result = $q->fetchAll();

		$res = array('res' => $result[0]['res'] );

		echo json_encode($res);
	}


// ******************************************************************************************
//								call tracking
// ******************************************************************************************

// таблица рекламных кампаний (реквизиты сайта)
	function proc_camp_table_reload(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select 
			promocamp_url,
			promocamp, 
			promocamp_id,
			script_test,
			phone_mask
		from tb_ct_promocamp 
		where of_id = :OF_ID;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'promocamp_url' => $row['promocamp_url'],
				'promocamp' => $row['promocamp'],
				'promocamp_id' => $row['promocamp_id'],
				'script_test' => $row['script_test'],
				'phone_mask' => $row['phone_mask'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','',''); }
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}

	// добавление/редактирование кампании (если нет кампании с txt_camp_id добавляет иначе правит
	function proc_do_camp_edt() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		
		$row_param = $_REQUEST['row_param'];
		$row = json_decode($row_param, true);
		//$logger->log("", PEAR_LOG_DEBUG);

		$promocamp_id = (int)$row[0]['promocamp_id'];
		$promocamp_url = $row[0]['promocamp_url'];
		$promocamp = $row[0]['promocamp'];
		$phone_mask = $row[0]['phone_mask'];
		$camp_tag = $row[0]['camp_tag'];
		$camp_script = $row[0]['camp_script'];
		
		$q = <<<EOS
		execute procedure FM_CT_CAMP_EDT(:OF_ID,:PROMOCAMP_ID,:PROMOCAMP_URL,:PROMOCAMP,:PHONE_MASK);
EOS;
		$q=$database->prepare($q);
		
		$q->bindParam(":OF_ID",$ofid);
		$q->bindParam(":PROMOCAMP_ID",$promocamp_id);
		$q->bindParam(":PROMOCAMP_URL",$promocamp_url);
		$q->bindParam(":PROMOCAMP",$promocamp);
		$q->bindParam(":PHONE_MASK",$phone_mask);
		
		$q->execute();

		$res = array('result' => 'ok');
		echo json_encode($res);
	}

	// удаление рекламной кампании
	function proc_do_camp_del() {
		global $session, $database, $logger;
		
		$ofid = (int)$session->of_id;
		$promocamp_id = $_REQUEST['campid'];

		$q = <<<EOS
		execute procedure FM_CT_CAMP_DEL(:OF_ID,:PROMOCAMP_ID)
EOS;
		$q=$database->prepare($q);
		$q->bindParam(":OF_ID",$ofid);
		$q->bindParam(":PROMOCAMP_ID",$promocamp_id);
		
		$q->execute();
		
		$res = array('res' => 'ok');
		echo json_encode($res);
	}	

	// параметры рекламной кампании
	function proc_get_camp_param() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$promocamp_id = $_REQUEST['campid'];

		$q = <<<EOS
		select first 1
			promocamp_url,
			promocamp, 
			promocamp_id,
			script_test,
			phone_mask
		from tb_ct_promocamp 
		where of_id = :OF_ID and promocamp_id = :PROMOCAMP_ID;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":PROMOCAMP_ID",$promocamp_id);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'promocamp_url' => $row['promocamp_url'],
				'promocamp' => $row['promocamp'],
				'promocamp_id' => $row['promocamp_id'],
				'script_test' => $row['script_test'],
				'phone_mask' => $row['phone_mask'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','',''); }
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}

	// определяем url проекта
	function proc_get_common_param() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
				
		$res = array('data' => HOST_URL );
		//$res = array('data' => '2wkbfebvjefvhevf' );

		echo json_encode($res);
	}
	
	
	// таблица рекламных каналов
	function proc_channel_table_reload(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select * from FM_CT_CHANNEL_LIST(:OF_ID);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'promochannel_id' => $row['promochannel_id'],
				'promosegment_id' => $row['promosegment_id'],
				'promochannel' => $row['promochannel'],
				'channelkeeper' => $row['channelkeeper'],
				'channel_inkey' => $row['channel_inkey'],
				'channel_outkey' => $row['channel_outkey'],
				'channeltype_id' => $row['channeltype_id'],
				'segment_name' => $row['segment_name'],
				'segment_online' => $row['segment_online'],
				'channeltype' => $row['channeltype'],
				'param' => $param

			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','','','','','','');	}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}


	// сиписок типов каналов
	function proc_get_channeltype_list(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select * from tb_ct_channeltype;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'channeltype_id' => $row['channeltype_id'],
				'channeltype' => $row['channeltype'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','');	}
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}

	// список рекламных сегментов
	function proc_get_promosegment_list(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select * from tb_ct_promosegment;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'promosegment_id' => $row['promosegment_id'],
				'segment_name' => $row['segment_name'],
				'segment_online' => $row['segment_online'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','');	}
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}

	// параметры рекламного канала
	function proc_get_channel_param() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$promochannel_id = (int)$_REQUEST['channelid'];
		//$logger->log("ch_id = ".$promochannel_id.' of_id = '.$ofid, PEAR_LOG_DEBUG);

		$q = <<<EOS
		select first 1 *
		from tb_ct_promochannel
		where of_id = :OF_ID and promochannel_id = :PROMOCHANNEL_ID;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":PROMOCHANNEL_ID",$promochannel_id);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'promochannel' => $row['promochannel'],
				'channeltype_id' => $row['channeltype_id'],
				'promosegment_id' => $row['promosegment_id'],
				'channelkeeper' => $row['channelkeeper'],
				'channel_inkey' => $row['channel_inkey'],
				'channel_outkey' => $row['channel_outkey'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','','',''); }
		//$res = array('data' => $tabrow );

		//echo json_encode($res);

		echo json_encode($tabrow);
	}


	// номера канала
	function proc_get_channel_number() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$promochannel_id = (int)$_REQUEST['channelid'];
		//$logger->log("ch_id = ".$promochannel_id.' of_id = '.$ofid, PEAR_LOG_DEBUG);

		$q = <<<EOS
		select * from FM_CT_CHANNEL_NUMBER_LIST(:OF_ID,:PROMOCHANNEL_ID);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":PROMOCHANNEL_ID",$promochannel_id);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'of_number_id' => $row['of_number_id'],
				'of_number' => $row['of_number'],
				'of_number_prefix' => $row['of_number_prefix'],
				'numberorder' => $row['numberorder'],
				'channelnumber_id' => $row['channelnumber_id'],
				'numkey' => $row['numkey'],
				'numstate' => $row['numstate'],
				'numcount' => $row['numcount'],
				'numchannel' => $row['numchannel'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','','','','','',''); }
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}


	// добавление/редактирование канала
	function proc_do_channel_edt() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		
		$row_param = $_REQUEST['row_param'];
		$row = json_decode($row_param, true);
		//$logger->log("", PEAR_LOG_DEBUG);
		
		$channel_numbers = $_REQUEST['channel_numbers'];
		/*$num = json_decode($channel_numbers, true);
		foreach($num as $key => $nc){
			$logger->log($nc, PEAR_LOG_DEBUG);
		}*/
		

		$promochannel_id = (int)$row[0]['promochannel_id'];
		$promosegment_id = (int)$row[0]['promosegment_id'];
		$promochannel = $row[0]['promochannel'];
		$channelkeeper = $row[0]['channelkeeper'];
		$channel_inkey = $row[0]['channel_inkey'];
		$channel_outkey = $row[0]['channel_outkey'];
		$channeltype_id = (int)$row[0]['channeltype_id'];

		$q = <<<EOS
		execute procedure FM_CT_CHANNEL_EDT(:OF_ID,:PROMOCHANNEL_ID,:PROMOSEGMENT_ID,:PROMOCHANNEL,:CHANNELKEEPER,:CHANNEL_INKEY,:CHANNEL_OUTKEY,:CHANNELTYPE_ID,:CHANNEL_NUMBERS);
EOS;
		$q=$database->prepare($q);
		
		$q->bindParam(":OF_ID",$ofid);
		$q->bindParam(":PROMOCHANNEL_ID",$promochannel_id);
		$q->bindParam(":PROMOSEGMENT_ID",$promosegment_id);
		$q->bindParam(":PROMOCHANNEL",$promochannel);
		$q->bindParam(":CHANNELKEEPER",$channelkeeper);
		$q->bindParam(":CHANNEL_INKEY",$channel_inkey);
		$q->bindParam(":CHANNEL_OUTKEY",$channel_outkey);
		$q->bindParam(":CHANNELTYPE_ID",$channeltype_id);
		$q->bindParam(":CHANNEL_NUMBERS",$channel_numbers);
		
		$q->execute();

		$res = array('result' => 'ok');
		echo json_encode($res);
	}

	// удаление канала
	function proc_do_channel_del() {
		global $session, $database, $logger;
		
		$ofid = (int)$session->of_id;
		$promochannel_id = $_REQUEST['promochannel_id'];

		$q = <<<EOS
		execute procedure FM_CT_CHANNEL_DEL(:OF_ID,:PROMOCHANNEL_ID)
EOS;
		$q=$database->prepare($q);
		$q->bindParam(":OF_ID",$ofid);
		$q->bindParam(":PROMOCHANNEL_ID",$promochannel_id);
		
		$q->execute();
		
		$res = array('res' => 'ok');
		echo json_encode($res);
	}	
	
	
	// список групп, в которые входит сотрудник
	function proc_get_emploee_group_list() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$user_id = (int)$_REQUEST['txt_user_id'];
		//$logger->log($ofid, PEAR_LOG_DEBUG);

		$q = <<<EOS
		
        select 
        v1.group_id,
        v1.group_name,
        case when v2.group_id is null then 0 else 1 end as user_group_key
        from
        tb_office_group v1 left join
        (select group_id from tb_office_user_group where user_id = :USER_ID) as v2
        on v1.group_id = v2.group_id
        where v1.of_id = :OF_ID		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":USER_ID",$user_id);
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'group_id' => $row['group_id'],
				'group_name' => $row['group_name'],
				'user_group_key' => $row['user_group_key'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','',''); }
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
	

	// список сотрудников принадлежащих определенной группе
	function proc_get_employee_for_group() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$txt_group_id = (int)$_REQUEST['txt_group_id'];
		//$logger->log($ofid, PEAR_LOG_DEBUG);

		$q = <<<EOS
        select * from FM_EMPLOYEE_FOR_GROUP(:OF_ID, :GROUP_ID);
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":GROUP_ID",$txt_group_id);

		//$q->bindParam(":USER_PHOTO_FILE", $user_photo_file,PDO::PARAM_LOB|PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			/*$fname = !empty($row['user_photo_name']) ? '../../'.AVATAR_PATH.$row['user_photo_name'] : '';
			$fcontent = $row['user_photo_file'];
			if(!empty($fname)){
				$f = fopen($fname,"wb"); 
				fwrite($f,$fcontent);
				fclose($f);
			}*/

			$row['user_photo_name'] = AVATAR_PATH.$row['user_photo_name'];
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'user_id' => $row['user_id'],
				'user_fio' => $row['user_fio'],
				'user_photo_name' => $row['user_photo_name'],
				//'user_photo_file' => $row['user_photo_file'],
				'group_id' => $row['group_id'],
				'group_key' => $row['group_key'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','','','',''); }
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
	
	
	// сохранение привязки сотрудников к группе
	function proc_employee_for_group_edt() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		
		$txt_group_id = $_REQUEST['txt_group_id'];
		$group_user = $_REQUEST['group_user'];

		$q = <<<EOS
		execute procedure FM_EMPLOYEE_FOR_GROUP_EDT(:OF_ID,:GROUP_ID,:GROUP_USER);
EOS;
		$q=$database->prepare($q);
		
		$q->bindParam(":OF_ID",$ofid);
		$q->bindParam(":GROUP_ID",$txt_group_id);
		$q->bindParam(":GROUP_USER",$group_user);
		
		$q->execute();

		$res = array('result' => 'ok');
		echo json_encode($res);
	}
	
	
	// детализация разговоров
/*
	function proc_get_stats_table() {
		global $session, $database_tar, $logger;

		$ofid = (int)$session->of_id;
		$txt_date1 = $_REQUEST['txt_date1'];
		$txt_date2 = $_REQUEST['txt_date2'];
		$employee_id = $_REQUEST['employee_id'];
		$page_row = 50;
		$page_number = $page_row * $_REQUEST['page_number'];
		
		$txt_calltype = (!empty($_REQUEST['txt_calltype'])) ? 'and calltype in ('.$_REQUEST['txt_calltype'].')' : 'and 1<>1';
		$txt_ats_number = (!empty($_REQUEST['txt_ats_number'])) ? 'and numbersystem = '.$_REQUEST['txt_ats_number'] : '';
		
		$txt_abonent_number = trim($_REQUEST['txt_abonent_number']);
		$txt_abonent_number = (!empty($txt_abonent_number)) ? "and (numbera like '".$txt_abonent_number."' or numberb like '".$txt_abonent_number."')" : '';
		
		//$logger->log($ofid, PEAR_LOG_DEBUG);
		
		$q = <<<EOS
		select first :PAGE_ROW skip :PAGE_NUMBER * from FM_REPORTACCOUNTMTR(:OF_ID,:STARTTM,:ENDTM,null) where 1=1 $txt_calltype $txt_ats_number $txt_abonent_number;
EOS;
		$q=$database_tar->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":STARTTM",$txt_date1);
		$q->bindValue(":ENDTM",$txt_date2);
		$q->bindValue(":PAGE_NUMBER",$page_number);
		$q->bindValue(":PAGE_ROW",$page_row);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$row['creattime'] = date("d-m-Y H:i:s", strtotime($row['creattime']));
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'calltype' => $row['calltype'],
				//'user_id' => $row['user_id'],
				//'user_fio' => $row['user_fio'],
				//'user_photo_name' => $row['user_photo_name'],
				//'user_photo_file' => $row['user_photo_file'],
				//'group_id' => $row['group_id'],
				//'group_key' => $row['group_key'],
				'count' => $q->rowCount(),
				'param' => $param
			);
		}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
*/

	function proc_get_stats_table() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$txt_date1 = $_REQUEST['txt_date1'];
		$txt_date2 = $_REQUEST['txt_date2'];
		$page_row = 20;
		$page_number = $page_row * $_REQUEST['page_number'];
		
		$txt_calltype = (!empty($_REQUEST['txt_calltype'])) ? 'and calltype in ('.$_REQUEST['txt_calltype'].')' : 'and 1<>1';
		$txt_ats_number = (!empty($_REQUEST['txt_ats_number'])) ? 'and numbersystem = '.$_REQUEST['txt_ats_number'] : '';

		$employee_id = trim($_REQUEST['employee_id']);
		$employee_id = (!empty($employee_id)) ? 'and user_id in ('.$employee_id.')' : '';
		
		$txt_abonent_number = trim($_REQUEST['txt_abonent_number']);
		$txt_abonent_number = (!empty($txt_abonent_number)) ? "and (numbera like '".$txt_abonent_number."' or numberb like '".$txt_abonent_number."')" : '';
		
		//$logger->log($ofid, PEAR_LOG_DEBUG);

		$q = <<<EOS
		select floor(count(*)/$page_row) as cnt 
		from FM_DETAIL_REPORT(:OF_ID,:STARTTM,:ENDTM) where 1=1 $txt_calltype $txt_ats_number $txt_abonent_number $employee_id;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":STARTTM",$txt_date1);
		$q->bindValue(":ENDTM",$txt_date2);
		$q->execute();
		$result = $q->fetchAll();
		$rowcount = $result[0]['cnt'];

		
		$q = <<<EOS
		select first :PAGE_ROW skip :PAGE_NUMBER 
		sessionid,
		creattime,
		numbera,
		numberb,
		realvolume,
		geographyname,
		distancename,
		pay,
		recordid,
		termreason,
		cause,
		answerdelay,
		flagsout,
		calltype,
		payablevolume,
		serviceblockid,
		messagetype,
		floatcash1,
		floatcash2,
		floatgraph,
		calluri,
		calldomain,
		numbersystem,
		calluri_name,
		user_id,
		user_fio,
		user_photo_name
		from FM_DETAIL_REPORT(:OF_ID,:STARTTM,:ENDTM) where 1=1 $txt_calltype $txt_ats_number $txt_abonent_number $employee_id;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":STARTTM",$txt_date1);
		$q->bindValue(":ENDTM",$txt_date2);
		$q->bindValue(":PAGE_NUMBER",$page_number);
		$q->bindValue(":PAGE_ROW",$page_row);

		//$logger->log($q, PEAR_LOG_DEBUG);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$row['creattime'] = date("d-m-Y H:i:s", strtotime($row['creattime']));
			$param = implode("|",$row);
			$tabrow[$key] = array(
				'sessionid' => $row['sessionid'],
				'creattime' => $row['creattime'],
				'numbera' => $row['numbera'],
				'numberb' => $row['numberb'],
				'realvolume' => $row['realvolume'],
				'geographyname' => $row['geographyname'],
				'distancename' => $row['distancename'],
				'pay' => $row['pay'],
				'recordid' => $row['recordid'],
				'termreason' => $row['termreason'],
				'cause' => $row['cause'],
				'answerdelay' => $row['answerdelay'],
				'flagsout' => $row['flagsout'],
				'calltype' => $row['calltype'],
				'payablevolume' => $row['payablevolume'],
				'serviceblockid' => $row['serviceblockid'],
				'messagetype' => $row['messagetype'],
				'floatcash1' => $row['floatcash1'],
				'floatcash2' => $row['floatcash2'],
				'floatgraph' => $row['floatgraph'],
				'calluri' => $row['calluri'],
				'calldomain' => $row['calldomain'],
				'numbersystem' => $row['numbersystem'],
				'calluri_name' => $row['calluri_name'],
				'user_id' => $row['user_id'],
				'user_fio' => $row['user_fio'],
				'user_photo_name' => $row['user_photo_name'],
				//'user_photo_file' => $row['user_photo_file'],
				//'count' => $q->rowCount(),
				'count' => $rowcount,
				'param' => $param
			);
		}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}

/*
	// детализация разговоров кол-во страниц
	function proc_get_stats_table_count() {
		global $session, $database_tar, $logger;

		$ofid = (int)$session->of_id;
		$txt_date1 = $_REQUEST['txt_date1'];
		$txt_date2 = $_REQUEST['txt_date2'];
		$page_row = 50;

		$txt_calltype = (!empty($_REQUEST['txt_calltype'])) ? 'and calltype in ('.$_REQUEST['txt_calltype'].')' : 'and 1<>1';
		$txt_ats_number = (!empty($_REQUEST['txt_ats_number'])) ? 'and numbersystem = '.$_REQUEST['txt_ats_number'] : '';

		$txt_abonent_number = trim($_REQUEST['txt_abonent_number']);
		$txt_abonent_number = (!empty($txt_abonent_number)) ? "and (numbera like '".$txt_abonent_number."' or numberb like '".$txt_abonent_number."')" : '';
		
		$q = <<<EOS
		select floor(count(*)/$page_row) as cnt from FM_REPORTACCOUNTMTR(:OF_ID,:STARTTM,:ENDTM,null) where 1=1 $txt_calltype $txt_ats_number $txt_abonent_number;
EOS;
		$q=$database_tar->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":STARTTM",$txt_date1);
		$q->bindValue(":ENDTM",$txt_date2);

		$q->execute();
		$result = $q->fetch();
		$res = array(
			'count' => $result['cnt']
		);
		
		echo json_encode($res);
	}
	


	
	
	
	
	
	
	
	// отчет kpi
	function proc_get_kpi_table() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$txt_date1 = $_REQUEST['txt_date1'];
		$txt_date2 = $_REQUEST['txt_date2'];
		$employee_id = $_REQUEST['employee_id'];
		$page_row = 50;
		$page_number = $page_row * $_REQUEST['page_number'];
		
		$employee_id = (!empty($employee_id)) ? ' and user_id in ('.$employee_id.') ' : '';
		
		
		//$logger->log($ofid.'    '.$txt_date1.'    '.$txt_date2.'    '.$employee_id, PEAR_LOG_DEBUG);
		
		$q = <<<EOS
		select first :PAGE_ROW skip :PAGE_NUMBER 
		USER_ID, 
		INCALL_CNT,
		OUTCALL_CNT,
		MISCALL_CNT,
		TAG_CNT,
		INCALL_MAXCNT,
		OUTCALL_MAXCNT,
		MISCALL_MAXCNT,
		TAG_MAXCNT,
		USER_FIO,
		USER_PHOTO_NAME,
		USER_PHOTO_FILE
		from FM_KPI_REPORT(:OF_ID,:STARTTM,:ENDTM) where 1=1 $employee_id
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":STARTTM",$txt_date1);
		$q->bindValue(":ENDTM",$txt_date2);
		$q->bindValue(":PAGE_NUMBER",$page_number);
		$q->bindValue(":PAGE_ROW",$page_row);
		//$q->bindValue(":EXPLOYEE_ID",$employee_id);

		$q->execute();
		$result = $q->fetchAll();
		
		foreach($result as $key => $row){

			$fname = !empty($result[0]['user_photo_name']) ? '../../'.AVATAR_PATH.$row['user_photo_name'] : '';
			$fcontent = $row['user_photo_file'];
			if(!empty($fname)){
				$f = fopen($fname,"wb"); 
				fwrite($f,$fcontent);
				fclose($f);
			}

			//$param = implode("|",$row);
			$tabrow[$key] = array(
				'user_id' => $row['user_id'],
				'user_fio' => $row['user_fio'],
				'incall_cnt' => $row['incall_cnt'],
				'outcall_cnt' => $row['outcall_cnt'],
				'miscall_cnt' => $row['miscall_cnt'],
				'tag_cnt' => $row['tag_cnt'],
				'incall_maxcnt' => $row['incall_maxcnt'],
				'outcall_maxcnt' => $row['outcall_maxcnt'],
				'miscall_maxcnt' => $row['miscall_maxcnt'],
				'tag_maxcnt' => $row['tag_maxcnt'],
				'user_photo_name' => $row['user_photo_name'],
				'count' => $q->rowCount()
				//'param' => $param
			);
		}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
	
	
	// рекламные кампании
	function proc_get_promocamp_list(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		select * from TB_CT_PROMOCAMP where of_id = :OF_ID;
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$param = "'".implode("|",$row)."'";
			$tabrow[$key] = array(
				'promocamp_id' => $row['promocamp_id'],
				'promocamp_url' => $row['promocamp_url'],
				'param' => $param
			);
		}
		if(empty($result)){ $tabrow[0] = array('','','');	}
		$res = array('data' => $tabrow );
		
		echo json_encode($res);
	}
	
	
	// отчет roi
	function proc_get_roi_table() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;
		$txt_date1 = $_REQUEST['txt_date1'];
		$txt_date2 = $_REQUEST['txt_date2'];
		$page_row = 50;
		$page_number = $page_row * $_REQUEST['page_number'];
		
		$txt_promocamp = $_REQUEST['txt_promocamp'];
		$webuser_id = '1111';
		
		$logger->log($ofid.'    '.$txt_date1.'    '.$txt_date2.'    '.$txt_promocamp.'    '.$webuser_id, PEAR_LOG_DEBUG);
		


		$q = <<<EOS
		select 
		promochannel,
		visitcount,
		ipvisitcount,
		callpercent,
		callweight,
		promochannel_id
		from ct_rpt_channel(:OF_ID,:PROMOCAMP_ID,:STARTTM,:ENDTM,:WEBUSER_ID) 
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":STARTTM",$txt_date1);
		$q->bindValue(":ENDTM",$txt_date2);
		$q->bindValue(":PROMOCAMP_ID",$txt_promocamp);
		$q->bindValue(":WEBUSER_ID",$webuser_id);

		$q->bindValue(":PAGE_NUMBER",$page_number);
		$q->bindValue(":PAGE_ROW",$page_row);
		
		$logger->log($q, PEAR_LOG_DEBUG);
		
		$q->execute();
		$result = $q->fetchAll();

		// определяем максимумы в колонках для масштабирования графиков
		$arr_visitcount = array();
		$arr_ipvisitcount = array();
		$arr_callpercent = array();
		$arr_callweight = array();
		foreach($result as $key => $row){
			$arr_visitcount[$key] = $row['visitcount'];
			$arr_ipvisitcount[$key] = $row['ipvisitcount'];
			$arr_callpercent[$key] = $row['callpercent'];
			$arr_callweight[$key] = $row['callweight'];
		}
		$max_visitcount = max($arr_visitcount);
		$max_ipvisitcount = max($arr_ipvisitcount);
		$max_callpercent = max($arr_callpercent);
		$max_callweight = max($arr_callweight);

		
		foreach($result as $key => $row){
			//$param = implode("|",$row);
			$tabrow[$key] = array(
				'promochannel' => $row['promochannel'],
				'visitcount' => $row['visitcount'],
				'ipvisitcount' => $row['ipvisitcount'],
				'callpercent' => $row['callpercent'],
				'callweight' => $row['callweight'],
				'promochannel_id' => $row['promochannel_id'],
				'max_visitcount' => $max_visitcount,
				'max_ipvisitcount' => $max_ipvisitcount,
				'max_callpercent' => $max_callpercent,
				'max_callweight' => $max_callweight,
				'count' => $q->rowCount()
				//'param' => $param
			);
		}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
	

	// параметры партнерки - промо-код,статус, и т.д. (если промо-код отсутствует создаем его)
	function proc_get_partner_param() {
		global $session, $database_tar, $logger;

		$ofid = (int)$session->of_id;
		//$logger->log('of_id = '.$ofid, PEAR_LOG_DEBUG);

		$q = <<<EOS
		execute procedure fm_partner_param(:OF_ID);
EOS;

		$q=$database_tar->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		
		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
			$tabrow[$key] = array(
				'emitterkcid' => $row['emitterkcid'],
				'accountid' => $row['accountid'],
				'accountgroupid' => $row['accountgroupid'],
				'promocode' => $row['promocode'],
				'tarifpoliticid' => $row['tarifpoliticid'],
				'abonid' => $row['abonid'],
				'discountid' => $row['discountid'],
				'discountname' => $row['discountname'],
				'discountsum' => $row['discountsum'],
				'fio' => $row['fio'],
				'partnerdate' => $row['partnerdate'],
				'awardsum' => $row['awardsum'],
				'abonname' => $row['abonname']
			);
		}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
	


	
	// часовой пояс
	function proc_get_timezone(){
		global $database_tar, $session, $logger;
	
		$ofid = (int)$session->of_id;
		$systimezone = (int)(-1*$_REQUEST['systimezone']/60);
		
		$q = <<<EOS
		execute procedure FM_GET_TIMEZONE(:OF_ID,:SYSTIMEZONE);
EOS;

		$q=$database_tar->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":SYSTIMEZONE",$systimezone);
		
		
		$q->execute();
		$res = $q->fetchAll();
		
		$utc = $res[0]['utc'];

		$res = array('utc' => $utc );
	
		echo json_encode($res);
	}
	
	// установка часового пояса 
	function proc_set_timezone(){
		global $database_tar, $session, $logger;
	
		$ofid = (int)$session->of_id;
		$systimezone = (int)$_REQUEST['systimezone'];
		
		$q = <<<EOS
		execute procedure FM_SET_TIMEZONE(:OF_ID,:SYSTIMEZONE);
EOS;

		$q=$database_tar->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":SYSTIMEZONE",$systimezone);
		
		$q->execute();
		$res = $q->fetchAll();
		
		$utc = $res[0]['utc'];

		$res = array('utc' => $utc );
	
		echo json_encode($res);
	}

	// сохранение параметров подключения к amoCRM
	function proc_set_amocrm_service(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;
		$external_system_id = 1;
		$txt_amocrm_login = $_REQUEST['txt_amocrm_login'];
		$txt_amocrm_password = $_REQUEST['txt_amocrm_password'];
		$txt_amocrm_subdomain = $_REQUEST['txt_amocrm_subdomain'];
		$external_system_param = $txt_amocrm_login.'|'.$txt_amocrm_password.'|'.$txt_amocrm_subdomain.'|';

		//$logger->log('of_id = '.$ofid.'    sys_id = '.$external_system_id.'    param = '.$external_system_param, PEAR_LOG_DEBUG);
		
		$q = <<<EOS
		execute procedure FM_EXTERNAL_SYSTEM_ADD(:OF_ID,:EXTERNAL_SYSTEM_ID,:EXTSYSTEM_PARAM_VALUE);
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":EXTERNAL_SYSTEM_ID",$external_system_id);
		$q->bindValue(":EXTSYSTEM_PARAM_VALUE",$external_system_param);

		$q->execute();
		$res = $q->fetchAll();
		
		//$utc = $res[0]['utc'];
		$res = array('data' => 'ok' );
		echo json_encode($res);
	}
	
	// получение параметров amoCRM
	function proc_get_amocrm_service(){
		global $database, $session, $logger;
	
		$ofid = (int)$session->of_id;
		$external_system_id = 1;

		$q = <<<EOS
		select 
		v1.extsystem_param_id,
		v1.extsystem_param_value,
		v3.extsystem_param_name 
		from tb_office_extsystem_param v1 inner join tb_office_external_system v2
		on v1.office_external_system_id = v2.office_external_system_id
		inner join tb_extsystem_param v3 on v1.extsystem_param_id = v3.extsystem_param_id
		where v2.of_id = :OF_ID and v2.external_system_id = :EXTERNAL_SYSTEM_ID;
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":EXTERNAL_SYSTEM_ID",$external_system_id);

		$q->execute();
		$res = $q->fetchAll();

		foreach($res as $key => $row){
			$tabrow[$key] = array(
				'extsystem_param_id' => $row['extsystem_param_id'],
				'extsystem_param_name' => $row['extsystem_param_name'],
				'extsystem_param_value' => $row['extsystem_param_value']
			);
		}
		$res = array('data' => $tabrow );

		echo json_encode($res);
	}
	

	// определение свободного номера sip-аккаунта, создание пароля
	function proc_user_sipaccount_freenumber(){
		global $database_tar, $session, $logger;
		
		//$userpass = strtoupper($this->generateRandStr(8));
		
		$q = <<<EOS
	select * from FM_SIPACCOUNT_NUMBER
EOS;

		$q=$database_tar->prepare($q);

		$q->execute();
		$res = $q->fetchAll();
		
		$freenumber = $res[0]['sipname'];
		
		$userpass = $this->generateRandStr(10);
		
		$res = array('ok'=>'yes', 'freenumber'=>$freenumber, 'userpass'=>$userpass);
		echo json_encode($res);
	}

	// случайный генератор строки
	function generateUserPass($len = 128) {
		return sha1($this->generateRandStr($len));
	}
	function generateRandStr($length) {
		$randstr = "";
		for ($i=0; $i<$length; $i++) {
			$randnum = mt_rand(0,61);
			if($randnum < 10){
				$randstr .= chr($randnum+48);
			} else if ($randnum < 36) {
				$randstr .= chr($randnum+55);
			} else{
				$randstr .= chr($randnum+61);
			}
		}
		return $randstr;
	}
*/

	// добавление графика
	function proc_graphic_add() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;

		$txt_graphic_name = $_REQUEST['txt_graphic_name'];
		$txt_graph_start = $_REQUEST['txt_graph_start'];
		$txt_graph_stop = $_REQUEST['txt_graph_stop'];
		$weekdays_list = $_REQUEST['weekdays_list'];
		$hollydays_list = $_REQUEST['hollydays_list'];


		$q = <<<EOS
		execute procedure FM_GRAPHIC_ADD(
		:OF_ID,
		:GRAPHIC_NAME,
		:START_TIME,
		:END_TIME,
		:WEEKDAYS_LIST,
		:HOLLYDAYS_LIST
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":GRAPHIC_NAME",$txt_graphic_name);
		$q->bindValue(":START_TIME",$txt_graph_start);
		$q->bindValue(":END_TIME",$txt_graph_stop);
		$q->bindValue(":WEEKDAYS_LIST",$weekdays_list);
		$q->bindValue(":HOLLYDAYS_LIST",$hollydays_list);

		/*
		$q->bindParam(":USER_ID",$user_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":DIALS_ID",$dials_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":EXT_NUMBER_ID",$ext_number_id,PDO::PARAM_STR|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":EMITTERKCID",$emitterkcid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":ACCOUNTID",$accountid,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		$q->bindParam(":SIP_ID",$sip_id,PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT);
		*/
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	// удаление графика
	function proc_graphic_del() {
		global $database, $logger;
		
		$txt_graphic_id = $_REQUEST['txt_graphic_id'];

		$q = <<<EOS
		execute procedure FM_GRAPHIC_DEL(?)
EOS;
		$q = $database->prepare($q);
		$res = $database->execute($q,array($txt_graphic_id));
		
		$res = array('res' => 'ok');
		echo json_encode($res);
	}

	// заполнение параметров графика на странице редактирования
	function proc_graphs_params() {
		global $database, $session, $logger;

		$txt_graphic_id = $_REQUEST['txt_graphic_id'];
		$ofid = (int)$session->of_id;

		$q = <<<EOS
		execute procedure FM_GRAPHIC_PARAMS( :GRAPH_ID );
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":GRAPH_ID",$txt_graphic_id);

		$q->execute();
		$result = $q->fetchAll();

		$res = array(
			'graph_name' => $result[0]['graph_name'],
			'start_time' => $result[0]['start_time'],
			'end_time' => $result[0]['end_time'],
			'weekdays' => $result[0]['weekdays'],
			'hollydays' => $result[0]['hollydays']
		);

		echo json_encode($res);
	}

	// редактирование графика
	function proc_graphic_edt() {
		global $session, $database, $logger;

		$ofid = (int)$session->of_id;

		$txt_graphic_id = $_REQUEST['txt_graphic_id'];
		$txt_graphic_name = $_REQUEST['txt_graphic_name'];
		$txt_graph_start = $_REQUEST['txt_graph_start'];
		$txt_graph_stop = $_REQUEST['txt_graph_stop'];
		$weekdays_list = $_REQUEST['weekdays_list'];
		$hollydays_list = $_REQUEST['hollydays_list'];


		$q = <<<EOS
		execute procedure FM_GRAPHIC_EDT(
		:OF_ID,
		:GRAPHIC_ID,
		:GRAPHIC_NAME,
		:START_TIME,
		:END_TIME,
		:WEEKDAYS_LIST,
		:HOLLYDAYS_LIST
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);
		$q->bindValue(":GRAPHIC_ID",$txt_graphic_id);
		$q->bindValue(":GRAPHIC_NAME",$txt_graphic_name);
		$q->bindValue(":START_TIME",$txt_graph_start);
		$q->bindValue(":END_TIME",$txt_graph_stop);
		$q->bindValue(":WEEKDAYS_LIST",$weekdays_list);
		$q->bindValue(":HOLLYDAYS_LIST",$hollydays_list);

		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	// информация по офису и счету
	function proc_get_office_account_info() {
		global $database, $session, $logger;

		$ofid = (int)$session->of_id;

		$q = <<<EOS
		execute procedure FM_OFFICE_ACCOUNT_INFO( :OF_ID );
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":OF_ID",$ofid);

		$q->execute();
		$result = $q->fetchAll();

		$res = array(
			'summ' => $result[0]['summ'],
			'tarifpoliticname' => $result[0]['tarifpoliticname'],
			'tarif' => $result[0]['tarif']
		);

		echo json_encode($res);
	}


//-------------------------------------------------------------------------------------------------

	function proc_save_db_options() {
		global $session, $database, $logger;

		$option_name = $_REQUEST['option_name'];
		$int_value = $_REQUEST['int_value'];
		$str_value = $_REQUEST['str_value'];
		$date_value = $_REQUEST['date_value'];
		$float_value = $_REQUEST['float_value'];
		$description = $_REQUEST['description'];
		$param_type = $_REQUEST['param_type'];
		$param_name = $_REQUEST['param_name'];
		$rowmode = $_REQUEST['rowmode'];
		
		$q = <<<EOS
		execute procedure DB_OPTIONS_EDT(
			:OPTION_NAME,
			:INT_VALUE,
			:STR_VALUE,
			:DATE_VALUE,
			:FLOAT_VALUE,
			:DESCRIPTION,
			:PARAM_TYPE,
			:PARAM_NAME,
			:ROWMODE
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":OPTION_NAME",$option_name);
		$q->bindValue(":INT_VALUE",$int_value);
		$q->bindValue(":STR_VALUE",$str_value);
		$q->bindValue(":DATE_VALUE",$date_value);
		$q->bindValue(":FLOAT_VALUE",$float_value);
		$q->bindValue(":DESCRIPTION",$description);
		$q->bindValue(":PARAM_TYPE",$param_type);
		$q->bindValue(":PARAM_NAME",$param_name);
		$q->bindValue(":ROWMODE",$rowmode);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_sip_ip_transport() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			protocol,
			ip,
			coalesce(port,'') as port,
			coalesce(name,'') as name,
			case when coalesce(cert_file,'')='' then ' ' else cert_file end as cert_file,
			case when coalesce(key_file,'')='' then ' ' else key_file end as key_file,
			coalesce(is_ip_v6,'') as is_ip_v6		
		from tb_sip_ip_transports;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'protocol' => $row['protocol'],
			'ip' => $row['ip'],
			'port' => $row['port'],
			'name' => $row['name'],
			'cert_file' => $row['cert_file'] == 'null' ? '' : $row['cert_file'],
			'key_file' => $row['key_file'] == 'null' ? '' : $row['key_file'],
			'is_ip_v6' => $row['is_ip_v6']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}


	function proc_save_sip_ip_transport() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$protocol = $_REQUEST['protocol'];
		$ip = $_REQUEST['ip'];
		$port = $_REQUEST['port'];
		$name = $_REQUEST['name'];
		$cert_file = $_REQUEST['cert_file'];
		$key_file = $_REQUEST['key_file'];
		$is_ip_v6 = $_REQUEST['is_ip_v6'];
		
		$q = <<<EOS
		execute procedure SIP_IP_TRANSPORT_EDT(
			:ID,
			:PROTOCOL,
			:IP,
			:PORT,
			:NAME,
			:CERT_FILE,
			:KEY_FILE,
			:IS_IP_V6
		)		
EOS;

		//$logger->log($q.'  id='.$id.'  protocol='.$protocol.'  port='.$port.'  is_ip_v6='.$is_ip_v6);

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":PROTOCOL",$protocol);
		$q->bindValue(":IP",$ip);
		$q->bindValue(":PORT",$port);
		$q->bindValue(":NAME",$name);
		$q->bindValue(":CERT_FILE",$cert_file,PDO::PARAM_LOB|PDO::PARAM_INPUT_OUTPUT);
		$q->bindValue(":KEY_FILE",$key_file,PDO::PARAM_LOB|PDO::PARAM_INPUT_OUTPUT);
		$q->bindValue(":IS_IP_V6",$is_ip_v6);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_sip_ip_transport() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure SIP_IP_TRANSPORT_DEL(
			:ID
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}


	function proc_get_sip_accounts() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select
			id,
			accounttypeid,
			tr_id,
			coalesce(dialplanid,'') as dialplanid,
			coalesce(fullname,'') as fullname,
			coalesce(calllimit,'') as calllimit,
			coalesce(name,'') as name,
			coalesce(secret,'') as secret,
			coalesce(secret_mode,'') as secret_mode,
			coalesce(reg_host,'') as reg_host,
			coalesce(reg_port,'') as reg_port,
			coalesce(expire,'') as expire,
			coalesce(realm,'') as realm,
			type_name,
			type_desc,
			trans_protocol,
			trans_ip,
			trans_port,
			trans_name
		from get_sip_accounts;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'accounttypeid' => $row['accounttypeid'],
			'tr_id' => $row['tr_id'],
			
			'dialplanid' => $row['dialplanid'] == 'null' ? '' : $row['dialplanid'],
			'fullname' => $row['fullname'] == 'null' ? '' : $row['fullname'],
			'calllimit' => $row['calllimit'] == 'null' ? '' : $row['calllimit'],
			'name' => $row['name'] == 'null' ? '' : $row['name'],
			'secret' => $row['secret'] == 'null' ? '' : $row['secret'],
			'secret_mode' => $row['secret_mode'] == 'null' ? '' : $row['secret_mode'],

			'reg_host' => $row['reg_host'] == 'null' ? '' : $row['reg_host'],
			'reg_port' => $row['reg_port'] == 'null' ? '' : $row['reg_port'],
			'expire' => $row['expire'] == 'null' ? '' : $row['expire'],
			'realm' => $row['realm'] == 'null' ? '' : $row['realm'],

			'type_name' => $row['type_name'],
			'type_desc' => $row['type_desc'],
			'trans_protocol' => $row['trans_protocol'],
			'trans_ip' => $row['trans_ip'],
			'trans_port' => $row['trans_port'],
			'trans_name' => $row['trans_name']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}

	function proc_get_sip_account_types() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select
			id,
			name,
			description
		from get_sip_account_types;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'name' => $row['name'],
			'description' => $row['description']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}

	function proc_save_sip_account() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		$accounttypeid = $_REQUEST['accounttypeid'];
		$tr_id = $_REQUEST['tr_id'];
		$dialplanid = $_REQUEST['dialplanid'];
		$fullname = $_REQUEST['fullname'];
		$calllimit = $_REQUEST['calllimit'];
		$name = $_REQUEST['name'];
		$secret = $_REQUEST['secret'];
		$secret_mode = $_REQUEST['secret_mode'];
		$reg_host = $_REQUEST['reg_host'];
		$reg_port = $_REQUEST['reg_port'];
		$expire = $_REQUEST['expire'];
		$realm = $_REQUEST['realm'];
		
		$q = <<<EOS
		execute procedure SIP_ACCOUNT_EDT(
			:ID,
			:ACCOUNTTYPEID,
			:TR_ID,
			:DIALPLANID,
			:FULLNAME,
			:CALLLIMIT,
			:NAME,
			:SECRET,
			:SECRET_MODE,
			:REG_HOST,
			:REG_PORT,
			:EXPIRE,
			:REALM
		)		
EOS;

		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		$q->bindValue(":ACCOUNTTYPEID",$accounttypeid);
		$q->bindValue(":TR_ID",$tr_id);
		$q->bindValue(":DIALPLANID",$dialplanid);
		$q->bindValue(":FULLNAME",$fullname);
		$q->bindValue(":CALLLIMIT",$calllimit);
		$q->bindValue(":NAME",$name);
		$q->bindValue(":SECRET",$secret);
		$q->bindValue(":SECRET_MODE",$secret_mode);
		$q->bindValue(":REG_HOST",$reg_host);
		$q->bindValue(":REG_PORT",$reg_port);
		$q->bindValue(":EXPIRE",$expire);
		$q->bindValue(":REALM",$realm);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}

	function proc_del_sip_account() {
		global $session, $database, $logger;

		$id = $_REQUEST['id'];
		
		$q = <<<EOS
		execute procedure SIP_ACCOUNT_DEL(
			:ID
		)		
EOS;
		$q=$database->prepare($q);
		$q->bindValue(":ID",$id);
		
		$q->execute();
		$result = $q->fetchAll();
		$res = array('result' => $result);

		echo json_encode($res);
	}
	

	function proc_get_active_sessions() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			is_incoming,
			cid,
			ses_type,
			ses_type_id,
            account_type,
            trans_name,
			astatus,
			fstatus,
			attr_to,
			attr_from,
			owner_user,
			from_host,
			from_port,
			expire,
			create_time,
			update_time
		from get_active_sessions;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'is_incoming' => $row['is_incoming'],
			'cid' => $row['cid'],
			'ses_type' => $row['ses_type'],
			'ses_type_id' => $row['ses_type_id'],
			'account_type' => $row['account_type'],
			'trans_name' => $row['trans_name'],
			'astatus' => $row['astatus'],
			'fstatus' => $row['fstatus'],
			'attr_to' => $row['attr_to'],
			'attr_from' => $row['attr_from'],
			'owner_user' => $row['owner_user'],
			'from_host' => $row['from_host'],
			'from_port' => $row['from_port'],
			'expire' => $row['expire'],
			'create_time' => $row['create_time'],
			'update_time' => $row['update_time']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}

	function proc_get_archive_sessions() {
		global $database, $session, $logger;
		
		$q = <<<EOS
		select 
			id,
			is_incoming,
			cid,
			ses_type,
			ses_type_id,
            account_type,
            trans_name,
			astatus,
			fstatus,
			uri_to,
			uri_from,
			owner_user,
			from_host,
			from_port,
			expire,
			create_time,
			update_time
		from get_archive_sessions;
EOS;
		$q=$database->prepare($q);

		$q->execute();
		$result = $q->fetchAll();

		foreach($result as $key => $row){
		$res[$key] = array(
			'id' => $row['id'],
			'is_incoming' => $row['is_incoming'],
			'cid' => $row['cid'],
			'ses_type' => $row['ses_type'],
			'ses_type_id' => $row['ses_type_id'],
			'account_type' => $row['account_type'],
			'trans_name' => $row['trans_name'],
			'astatus' => $row['astatus'],
			'fstatus' => $row['fstatus'],
			'uri_to' => $row['uri_to'],
			'uri_from' => $row['uri_from'],
			'owner_user' => $row['owner_user'],
			'from_host' => $row['from_host'],
			'from_port' => $row['from_port'],
			'expire' => $row['expire'],
			'create_time' => $row['create_time'],
			'update_time' => $row['update_time']
		);
		}
		
		if(!$res || empty($res)){ $res[0] = array('',''); }

		echo json_encode($res);
	}
	
	
	
	
};

$process = new Process;

?>