$(document).ready( function () {
	get_db_options();
});

function get_db_options(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_db_options'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['option_name']);
			//$.each(data, function (index, value) {
			//	alert(value['option_name']+' '+value['int_value']);
			//});
			$.each(data, function (index, value) {
				addDBOptionTableRow(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_db_options');
		}
	});
	
	return result;
}

function getInputClass(val){
	if(val == null){
		class_str = " \"inputTableCellNull inputTableCellNullHide inputTableCellNullChecked\" readonly ";
	} else {
		class_str = " \"inputTableCellNull inputTableCellNullHide inputTableCellNullUnchecked\" ";
	}
	return class_str;
}
function getCheckboxClass(val){
	if(val == null){
		class_str = " \"checkTableCellNull checkTableCellNullHide\" checked title=\"unset null\" ";
	} else {
		class_str = " \"checkTableCellNull checkTableCellNullHide\" title=\"set null\" ";
	}
	return class_str;
}
function getCellInnerHtml(row_id,field_name,field_value){
	var html_str = "";
	html_str =	''+field_value+'';
	html_str =	'<input row_id='+row_id+' col_id="'+field_name+'" type="text" class=' + getInputClass(field_value) + ' style="" value="' + field_value + '" \
	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,50,this);" /> \
	<input type="checkbox" class=' + getCheckboxClass(field_value) + ' \
	onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';
	return html_str;
}


function addDBOptionTableRow(value){
	var tab = $('table[id=tab_dboptions]')[0];
	
	var row_mode = "";
	if(!value || value==null){
		value = {
			"option_name": "", 
			"int_value": "", 
			"str_value": "", 
			"date_value": "", 
			"float_value": "", 
			"description": "", 
			"param_type": "", 
			"param_name": "" 
		};
		row_mode = "a";
	}

	var row_id = $('tr[type=optionrow]').length;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","optionrow");
	tr.setAttribute("row_id",row_id);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.innerHTML =	row_id;
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.setAttribute("type","optioncell");
	td.setAttribute("row_id",row_id);
	td.id = "option_name_"+row_id;
	td.innerHTML =	'<input row_id='+row_id+' col_id="option_name" type="text" class="inputTableCell" value="' + value['option_name'] + '" oninput="debounceEdtDBOption(this)" />';
		/*var input = document.createElement("input");
		input.type = "text";
		input.className = "inputTableCell";
		input.setAttribute("row_id",row_id);
		input.setAttribute("col_id","option_name");
		input.value = value['option_name'];
		td.appendChild(input);*/
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="int_value" type="text" class="inputTableCell" value="' + value['int_value'] + '" oninput="debounceEdtDBOption(this)" />';

	//td.innerHTML =	'<input row_id='+row_id+' col_id="int_value" type="text" class=' + getInputClass(value['int_value']) + ' style="" value="' + value['int_value'] + '" \
	//oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,100,this);" /> \
	//<input type="checkbox" class=' + getCheckboxClass(value['int_value']) + ' title="set null" \
	//onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';

	td.innerHTML = getCellInnerHtml(row_id,'int_value',value['int_value']);

	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
//	td.innerHTML =	'<input row_id='+row_id+' col_id="str_value" type="text" class="inputTableCellNull inputTableCellNullHide" style="" value="' + value['str_value'] + '" \
//	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(function(){inputTableCellNullBlur(this);},200);" /> \
//	<input type="checkbox" class="checkTableCellNull checkTableCellNullHide" title="set null" onchange="checkTableCellNullSet(this);" />';

//	td.innerHTML =	'<input row_id='+row_id+' col_id="str_value" type="text" class="inputTableCellNull inputTableCellNullHide" style="" value="' + value['str_value'] + '" \
//	oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,100,this);" /> \
//	<input type="checkbox" class="checkTableCellNull checkTableCellNullHide" title="set null" \
//	onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';

	//td.innerHTML =	'<input row_id='+row_id+' col_id="str_value" type="text" class=' + getInputClass(value['str_value']) + ' style="" value="' + value['str_value'] + '" \
	//oninput="debounceEdtDBOption(this)" onfocus="inputTableCellNullFocus(this);" onblur="setTimeout(inputTableCellNullBlur,100,this);" /> \
	//<input type="checkbox" class=' + getCheckboxClass(value['str_value']) + ' title="set null" \
	//onchange="checkTableCellNullSet(this);" onblur="setTimeout(checkTableCellNullBlur,50,this);" />';
	
	td.innerHTML = getCellInnerHtml(row_id,'str_value',value['str_value']);


	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="date_value" type="text" class="inputTableCell" value="' + value['date_value'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'date_value',value['date_value']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="float_value" type="text" class="inputTableCell" value="' + value['float_value'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'float_value',value['float_value']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="description" type="text" class="inputTableCell" value="' + value['description'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'description',value['description']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="param_type" type="text" class="inputTableCell" value="' + value['param_type'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'param_type',value['param_type']);
	tr.appendChild(td);
	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<input row_id='+row_id+' col_id="param_name" type="text" class="inputTableCell" value="' + value['param_name'] + '" oninput="debounceEdtDBOption(this)" />';
	td.innerHTML = getCellInnerHtml(row_id,'param_name',value['param_name']);
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	//td.innerHTML =	'<img src="../inc/img/del.gif" style="width:1.2em;height:1.2em;text-align:center;vertical-align:middle;cursor:pointer;" title="delete option" onclick="delDBOptionTableRow(this.parent.parent)">';
	td.innerHTML =	'<img src="../inc/img/del.gif" style="width:1.2em;height:1.2em;text-align:center;vertical-align:middle;cursor:pointer;" title="delete option" onclick="delDBOptionTableRow(this.parentElement.parentElement)">';
	tr.appendChild(td);

	var td = document.createElement("td");
	td.className = "infoTableCell";
	td.style.display = "none";
	td.id = "rowmode_"+row_id;
	td.innerHTML =	row_mode;
	tr.appendChild(td);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
    });	

	if(row_mode == "a") $(tr).children('td').children('input').css("backgroundColor","#c4ffc4");
}

function delDBOptionTableRow(obj){
	var row_id = obj.getAttribute('row_id');

	var row_mode_obj = $('td[id=rowmode_'+row_id+']',obj)[0];
	var row_mode = $('td[id=rowmode_'+row_id+']',obj)[0].innerHTML;
	if(row_mode == "a") obj.remove();

	if(row_mode == ""){
		row_mode_obj.innerHTML = "d";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "line-through");
		$('input[row_id='+row_id+']',obj).css("font-style", "italic");
		$('input[row_id='+row_id+']',obj).css("color", "#ff4444");
	}
	if(row_mode == "d"){
		row_mode_obj.innerHTML = "";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "none");
		$('input[row_id='+row_id+']',obj).css("font-style", "normal");
		$('input[row_id='+row_id+']',obj).css("color", "#333");
	}

	if(row_mode == "e"){
		row_mode_obj.innerHTML = "ed";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "line-through");
		$('input[row_id='+row_id+']',obj).css("font-style", "italic");
		$('input[row_id='+row_id+']',obj).css("color", "#ff4444");
	}
	if(row_mode == "ed"){
		row_mode_obj.innerHTML = "e";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "none");
		$('input[row_id='+row_id+']',obj).css("font-style", "normal");
		$('input[row_id='+row_id+']',obj).css("color", "#333");
	}


	
	/*
	if(row_mode.innerHTML == ""){
		row_mode.innerHTML = "d";
		$('input[row_id='+row_id+']',obj).css("text-decoration", "line-through");
	} else {
		if(row_mode.innerHTML == "d"){
			row_mode.innerHTML = "";
			$('input[row_id='+row_id+']',obj).css("text-decoration", "none");
		}
	}
	*/
}


// дебонсинг события редактирования
function debounce(func, wait, immediate) {
	var timeout;
	return function() {
		var context = this, args = arguments;
		clearTimeout(timeout);
		timeout = setTimeout(function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		}, wait);
		if (immediate && !timeout) func.apply(context, args);
	};
}

var debounceEdtDBOption = debounce(function(obj){
	EdtDBOption(obj);
}, 250);

function EdtDBOption(obj){
	var row_obj = obj.parentElement.parentElement;
	var row_id = row_obj.getAttribute('row_id');
	//obj.style.backgroundColor = "#ff8080";
	var row_mode_obj = $('td[id=rowmode_'+row_id+']',row_obj)[0];
	var row_mode = $('td[id=rowmode_'+row_id+']',row_obj)[0].innerHTML;
	if(row_mode != "a") {
		$(row_obj).children('td').children('input').css("backgroundColor","#ffc4c4");
		if(row_mode == "d" || row_mode == "ed") row_mode_obj.innerHTML = "ed";
		else row_mode_obj.innerHTML = "e";
	}
}


function onSaveClick(){
	$('tr[type=optionrow]').each(function( index ) {
		//alert(index);
		//var obj = $(this).children('td').children('input')
		//var option_name = obj[0].value;
		var row_id = $(this).attr('row_id');
		
		var option_name = $('input[col_id=option_name][row_id='+row_id+']','td', this)[0].value;
		var int_value = $('input[col_id=int_value][row_id='+row_id+']','td', this)[0].value;
		var str_value = $('input[col_id=str_value][row_id='+row_id+']','td', this)[0].value;
		var date_value = $('input[col_id=date_value][row_id='+row_id+']','td', this)[0].value;
		var float_value = $('input[col_id=float_value][row_id='+row_id+']','td', this)[0].value;
		var description = $('input[col_id=description][row_id='+row_id+']','td', this)[0].value;
		var param_type = $('input[col_id=param_type][row_id='+row_id+']','td', this)[0].value;
		var param_name = $('input[col_id=param_name][row_id='+row_id+']','td', this)[0].value;
		
		var rowmode = $('td[id=rowmode_'+row_id+']',this)[0].innerHTML;
		//if(rowmode != '') alert(rowmode+' '+option_name);


		if(!int_value || int_value==null || int_value=='null') int_value = "";
		//if(!str_value || str_value==null || str_value=='null') str_value = "";
		if(!date_value || date_value==null || date_value=='null') date_value = "";
		if(!float_value || float_value==null || float_value=='null') float_value = "";
		//if(!description || description==null || description=='null') description = "";
		if(!param_type || int_value==null || param_type=='null') param_type = "";
		if(!param_name || param_name==null || param_name=='null') param_name = "";

		//zz = option_name+", "+int_value+", "+str_value+", "+date_value+", "+float_value+", "+description+", "+param_type+", "+param_name+", "+rowmode;
		//alert(zz);
		
		save_db_options(option_name, int_value, str_value, date_value, float_value, description, param_type, param_name, rowmode);
		
		/*$('td', this).each(function(i) {
			alert( $('input', this)[0].value );
		});*/
		//$('input','td', this).each(function(i) {
		//	alert( $(this)[0].value );
		//});

		//var rid = $(this).attr('row_id');
		//var val = $('input[row_id='+row_id+'')[0];
		//alert( val );
	});
}

function save_db_options(option_name, int_value, str_value, date_value, float_value, description, param_type, param_name, rowmode){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_db_options',
			option_name: option_name,
			int_value: int_value,
			str_value: str_value,
			date_value: date_value,
			float_value: float_value,
			description: description,
			param_type: param_type,
			param_name: param_name,
			rowmode: rowmode
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_db_options');
		}
	});
}


function inputTableCellNullFocus(obj){
	//$('input.inputTableCellNull').removeClass( "inputTableCellNullShow" ).addClass( "inputTableCellNullHide" );
	var ch = $(obj).next('[type=checkbox]')[0];
	$(obj).removeClass( "inputTableCellNullHide" ).addClass( "inputTableCellNullShow" );
	$(ch).removeClass( "checkTableCellNullHide" ).addClass( "checkTableCellNullShow" );
}

function inputTableCellNullBlur(obj){
	var ch = $(obj).next('[type=checkbox]')[0];
	var ac = document.activeElement;
	if( ac != ch ){
		$(obj).removeClass( "inputTableCellNullShow" ).addClass( "inputTableCellNullHide" );
		$(ch).removeClass( "checkTableCellNullShow" ).addClass( "checkTableCellNullHide" );
	}
}
function checkTableCellNullBlur(obj){
	var inp = $(obj).prev('input[type=text]')[0];
	var ac = document.activeElement;
	if( ac != inp ){
		$(inp).removeClass( "inputTableCellNullShow" ).addClass( "inputTableCellNullHide" );
		$(obj).removeClass( "checkTableCellNullShow" ).addClass( "checkTableCellNullHide" );
	}
}


function checkTableCellNullSet(obj){
	var inp = $(obj).prev('input[type=text]')[0];
	EdtDBOption(inp);
	if(obj.checked) {
		obj.setAttribute('title','unset null');
		inp.value = "null";
		inp.setAttribute("readonly","true");
		/*$(inp).css("background", "var(--grey-light)");
		$(inp).css("color", "var(--grey-light)");*/
		$(inp).removeClass( "inputTableCellNullUnchecked" ).addClass( "inputTableCellNullChecked" );
	} else {
		obj.setAttribute('title','set null');
		inp.value = "";
		inp.removeAttribute('readonly');
		/*$(inp).css("background", "#fff");
		$(inp).css("color", "var(--grey-dark)");
		inp.focus();*/
		$(inp).removeClass( "inputTableCellNullChecked" ).addClass( "inputTableCellNullUnchecked" );
	}
}
