var aDelTransID = [];

$(document).ready( function () {
	get_sip_ip_transport();
});

function get_sip_ip_transport(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_ip_transport'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['name']);
			$.each(data, function (index, value) {
				addSipIpTransport(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_sip_ip_transport');
		}
	});
	
	return result;
}




function addSipIpTransport(value){
	var container = $('td[id=sip_ip_transport_container]')[0];

	document.getElementById("hidSipIpTransportCount").value++;
	// idx - unique block number on page, not id of transport in the database
	var idx = document.getElementById("hidSipIpTransportCount").value;
	
	/*
	var blocks = $('table[type=sip_ip_transport]');
	var block_count = 0;
	if(blocks.length > 0) block_count = blocks.length; 
	block_count++;
	*/
	
	if(!value || value==null){
		value = {
			"id": "", 
			"protocol": "", 
			"ip": "", 
			"port": "", 
			"name": "", 
			"cert_file": "", 
			"key_file": "", 
			"is_ip_v6": ""
		};
	}

	var tab = document.createElement("table");
	tab.className = "dataBlock_light";
	tab.setAttribute("type","sip_ip_transport");
	tab.setAttribute("idx",idx);
	tab.setAttribute("block_trans_id",value["id"]);

	tab.onclick = function() {
		var blocks = $('table[type=sip_ip_transport]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trTransportHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }

		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trTransportHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		  
		});
	};


	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","trTransportHeader");
	var td = document.createElement("td");
	td.colSpan = 2;
	td.className = "editTableHeader";
	td.innerHTML = "<div style=\"display:inline;float:left\">&nbsp; Transport #"+idx+"&nbsp;</div>"+
	"<img class=\"imglink\" style=\"display:inline;float:right;margin-right:2px;\" onclick=\"delSipIpTransport(this);\" title=\"Delete Transport\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);
	tab.appendChild(tr);


	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"id";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_id_"+idx+"\" id=\"edTrans_id_"+idx+"\" type=\"text\" value=\""+value["id"]+"\" class=\"selectw\" disabled=\"true\" >";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"protocol";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	//td.innerHTML =	"<input name=\"edTrans_protocol_"+idx+"\" id=\"edTrans_protocol_"+idx+"\" type=\"text\" value=\""+value["protocol"]+"\" class=\"selectw\">";
	td.innerHTML = "<select name=\"edTrans_protocol_"+idx+"\" id=\"edTrans_protocol_"+idx+"\" class=\"selectw\" onchange=\"onTransChangeProtocol("+idx+")\" >"+
					"<option value=\"tcp\" "+GetSelectedString(value["protocol"], "tcp")+">tcp</option>"+
					"<option value=\"udp\" "+GetSelectedString(value["protocol"], "udp")+">udp</option>\n"+
					"</select>\n";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"ip";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_ip_"+idx+"\" id=\"edTrans_ip_"+idx+"\" type=\"text\" value=\""+value["ip"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"port";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_port_"+idx+"\" id=\"edTrans_port_"+idx+"\" type=\"text\" value=\""+value["port"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"name";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_name_"+idx+"\" id=\"edTrans_name_"+idx+"\" type=\"text\" value=\""+value["name"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"cert_file";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_cert_file_"+idx+"\" id=\"edTrans_cert_file_"+idx+"\" type=\"text\" value=\""+value["cert_file"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"key_file";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_key_file_"+idx+"\" id=\"edTrans_key_file_"+idx+"\" type=\"text\" value=\""+value["key_file"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"is_ip_v6";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	td.innerHTML =	"<input name=\"edTrans_is_ip_v6_"+idx+"\" id=\"edTrans_is_ip_v6_"+idx+"\" type=\"text\" value=\""+value["is_ip_v6"]+"\" class=\"selectw\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	container.appendChild(tab);
	
	if(value["port"] == "" && value["ip"] == "") onTransChangeProtocol(idx);
}

function delSipIpTransport(obj){
	obj.parentElement.parentElement.parentElement.remove();
	var obj_id = obj.parentElement.parentElement.parentElement.getAttribute('block_trans_id');
	aDelTransID.push(obj_id);
}





/*
// дебонсинг события редактирования
function debounce(func, wait, immediate) {
	var timeout;
	return function() {
		var context = this, args = arguments;
		clearTimeout(timeout);
		timeout = setTimeout(function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		}, wait);
		if (immediate && !timeout) func.apply(context, args);
	};
}

var debounceEdtDBOption = debounce(function(obj){
	EdtDBOption(obj);
}, 250);

function EdtDBOption(obj){
	var row_obj = obj.parentElement.parentElement;
	var row_id = row_obj.getAttribute('row_id');
	//obj.style.backgroundColor = "#ff8080";
	var row_mode_obj = $('td[id=rowmode_'+row_id+']',row_obj)[0];
	var row_mode = $('td[id=rowmode_'+row_id+']',row_obj)[0].innerHTML;
	if(row_mode != "a") {
		$(row_obj).children('td').children('input').css("backgroundColor","#ffc4c4");
		if(row_mode == "d" || row_mode == "ed") row_mode_obj.innerHTML = "ed";
		else row_mode_obj.innerHTML = "e";
	}
}
*/

function onSaveClick(){

	var blocks = $('table[type=sip_ip_transport]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edTrans_id_"+idx).value;
		var protocol = document.getElementById("edTrans_protocol_"+idx).value;
		var ip = document.getElementById("edTrans_ip_"+idx).value;
		var port = document.getElementById("edTrans_port_"+idx).value;
		var name = document.getElementById("edTrans_name_"+idx).value;
		var cert_file = document.getElementById("edTrans_cert_file_"+idx).value;
		var key_file = document.getElementById("edTrans_key_file_"+idx).value;
		var is_ip_v6 = document.getElementById("edTrans_is_ip_v6_"+idx).value;

		//if(!port || port==null || port=='null') port = "";
		//if(!is_ip_v6 || is_ip_v6==null || is_ip_v6=='null') is_ip_v6 = "";
		
		save_sip_ip_transport(id,protocol,ip,port,name,cert_file,key_file,is_ip_v6);
	});
	
	$(aDelTransID).each(function(index,value){
		//alert(value);
		del_sip_ip_transport(value);
	});
	

	/*
	$('tr[type=optionrow]').each(function( index ) {
		//alert(index);
		//var obj = $(this).children('td').children('input')
		//var option_name = obj[0].value;
		var row_id = $(this).attr('row_id');
		
		var option_name = $('input[col_id=option_name][row_id='+row_id+']','td', this)[0].value;
		var int_value = $('input[col_id=int_value][row_id='+row_id+']','td', this)[0].value;
		var str_value = $('input[col_id=str_value][row_id='+row_id+']','td', this)[0].value;
		var date_value = $('input[col_id=date_value][row_id='+row_id+']','td', this)[0].value;
		var float_value = $('input[col_id=float_value][row_id='+row_id+']','td', this)[0].value;
		var description = $('input[col_id=description][row_id='+row_id+']','td', this)[0].value;
		var param_type = $('input[col_id=param_type][row_id='+row_id+']','td', this)[0].value;
		var param_name = $('input[col_id=param_name][row_id='+row_id+']','td', this)[0].value;
		
		var rowmode = $('td[id=rowmode_'+row_id+']',this)[0].innerHTML;
		//if(rowmode != '') alert(rowmode+' '+option_name);


		if(!int_value || int_value==null || int_value=='null') int_value = "";
		//if(!str_value || str_value==null || str_value=='null') str_value = "";
		if(!date_value || date_value==null || date_value=='null') date_value = "";
		if(!float_value || float_value==null || float_value=='null') float_value = "";
		//if(!description || description==null || description=='null') description = "";
		if(!param_type || int_value==null || param_type=='null') param_type = "";
		if(!param_name || param_name==null || param_name=='null') param_name = "";

		
		save_db_options(option_name, int_value, str_value, date_value, float_value, description, param_type, param_name, rowmode);
		
	});
	*/
}

function save_sip_ip_transport(id,protocol,ip,port,name,cert_file,key_file,is_ip_v6){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_sip_ip_transport',
			id: id,
			protocol: protocol,
			ip: ip,
			port: port,
			name: name,
			cert_file: cert_file,
			key_file: key_file,
			is_ip_v6: is_ip_v6
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_sip_ip_transport');
		}
	});
}


function del_sip_ip_transport(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_sip_ip_transport',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_sip_ip_transport');
		}
	});
}

function onTransChangeProtocol(idx){
	var protocol = document.getElementById("edTrans_protocol_"+idx).value;
	var port = document.getElementById("edTrans_port_"+idx);
	//if(port.value==""){
		if(protocol=="tcp") port.value = "5061";
		if(protocol=="udp") port.value = "5060";
	//}
}