var aDelAccountID = [];

$(document).ready( function () {
	get_sip_accounts();
});

function get_sip_accounts(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_accounts'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['name']);
			$.each(data, function (index, value) {
				if(value['accounttypeid'] < 4) addSipAccount_D(value);		//Registered
				if(value['accounttypeid'] == 4) addSipAccount_R(value);	//Registrar
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_sip_accounts');
		}
	});
	
	return result;
}

function get_sip_account_types(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_account_types'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			result = data;
		},
		error:function(){
			alert('error: get_sip_account_types');
		}
	});
	
	return result;
}

function make_select_sip_account_types(val,stype){
	var selstr = "";
	var acctype = get_sip_account_types();
	$(acctype).each(function(index,value) {
		if(stype == "D" && value['id'] < 4)
		selstr += "<option value="+value['id']+" "+GetSelectedString(value['id'], val)+">"+value['name']+"</option>";
		if(stype == "R" && value['id'] == 4)
		selstr += "<option value="+value['id']+" "+GetSelectedString(value['id'], val)+">"+value['name']+"</option>";
	});
	return selstr;
}

function get_sip_ip_transports(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_sip_ip_transport'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			result = data;
		},
		error:function(){
			alert('error: get_sip_ip_transport');
		}
	});
	
	return result;
}

function make_select_sip_ip_transports(val){
	var selstr = "";
	var siptrans = get_sip_ip_transports();
	$(siptrans).each(function(index,value) {
		selstr += "<option value="+value['id']+" "+GetSelectedString(value['id'], val)+">"+value['name']+"</option>";
	});
	return selstr;
}


function addSipAccount_D(value){
	var container = $('td[id=sip_account_D_container]')[0];

	document.getElementById("hidSipAccountDCount").value++;
	// idx - unique block number on page, not id of transport in the database
	var idx = document.getElementById("hidSipAccountDCount").value;
	
	if(!value || value==null){
		value = {
			"id": "", 
			"accounttypeid": "",
			"tr_id": "", 
			"dialplanid": "", 
			"fullname": "", 
			"calllimit": "", 
			"name": "", 
			"secret": "", 
			"secret_mode": "", 
			"reg_host": "", 
			"reg_port": "", 
			"expire": "", 
			"realm": "", 
			"type_name": "", 
			"type_desc": "", 
			"trans_protocol": "", 
			"trans_ip": "", 
			"trans_port": "", 
			"trans_name": ""
		};
	}

	var tab = document.createElement("table");
	tab.className = "dataBlock_light";
	tab.setAttribute("type","sip_account_D");
	tab.setAttribute("idx",idx);
	tab.setAttribute("block_id",value["id"]);

	tab.onclick = function() {
		var blocks = $('table[type=sip_account_D]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trBlockHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }
		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trBlockHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		});
	};

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","trBlockHeader");
	var td = document.createElement("td");
	td.colSpan = 2;
	td.className = "editTableHeader";
	td.innerHTML = "<div style=\"display:inline;float:left\">&nbsp; Resource #"+idx+"&nbsp;</div>"+
	"<img class=\"imglink\" style=\"display:inline;float:right;margin-right:2px;\" onclick=\"delSipAccount(this);\" title=\"Delete Resource\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	AddTableRow(tab, "id",
		"<input name=\"edResD_id_"+idx+"\" " +
		"id=\"edResD_id_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["id"]+"\" " +
		"class=\"selectw\">");

	/*tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"accounttypeid";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	var opstr = make_select_sip_account_types(value["accounttypeid"]);

	td.innerHTML = "<select name=\"edResD_accounttypeid_"+idx+"\" id=\"edResD_accounttypeid_"+idx+"\" class=\"selectw\">"+
					opstr+
					"</select>\n";
	tr.appendChild(td);
	tab.appendChild(tr);

	tr = document.createElement("tr");
	td = document.createElement("td");
	td.className = "editLineParam";
	td.innerHTML =	"tr_id";
	tr.appendChild(td);
	td = document.createElement("td");
	td.className = "editLineValue";
	var opstr = make_select_sip_ip_transports(value["tr_id"]);

	td.innerHTML = "<select name=\"edResD_tr_id_"+idx+"\" id=\"edResD_tr_id_"+idx+"\" class=\"selectw\">"+
					opstr+
					"</select>\n";
	tr.appendChild(td);
	tab.appendChild(tr);*/

	var opstr = make_select_sip_account_types(value["accounttypeid"],"D");
	AddTableRow(tab, "accounttypeid",
		"<select name=\"edResD_accounttypeid_"+idx+"\" " +
		"id=\"edResD_accounttypeid_"+idx+"\" " +
		"class=\"selectw\">" + 
		opstr + 
		"</select>\n");

	var opstr = make_select_sip_ip_transports(value["tr_id"]);
	AddTableRow(tab, "tr_id",
		"<select name=\"edResD_tr_id_"+idx+"\" " +
		"id=\"edResD_tr_id_"+idx+"\" " +
		"class=\"selectw\">" + 
		opstr + 
		"</select>\n");

	AddTableRow(tab, "dialplanid",
		"<input name=\"edResD_dialplanid_"+idx+"\" " +
		"id=\"edResD_dialplanid_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["dialplanid"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "fullname",
		"<input name=\"edResD_fullname_"+idx+"\" " +
		"id=\"edResD_fullname_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["fullname"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "calllimit",
		"<input name=\"edResD_calllimit_"+idx+"\" " +
		"id=\"edResD_calllimit_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["calllimit"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "name",
		"<input name=\"edResD_name_"+idx+"\" " +
		"id=\"edResD_name_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["name"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "secret",
		"<input name=\"edResD_secret_"+idx+"\" " +
		"id=\"edResD_secret_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["secret"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "secret_mode",
		"<input name=\"edResD_secret_mode_"+idx+"\" " +
		"id=\"edResD_secret_mode_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["secret_mode"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "reg_host",
		"<input name=\"edResD_reg_host_"+idx+"\" " +
		"id=\"edResD_reg_host_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["reg_host"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "reg_port",
		"<input name=\"edResD_reg_port_"+idx+"\" " +
		"id=\"edResD_reg_port_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["reg_port"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "expire",
		"<input name=\"edResD_expire_"+idx+"\" " +
		"id=\"edResD_expire_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["expire"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "realm",
		"<input name=\"edResD_realm_"+idx+"\" " +
		"id=\"edResD_realm_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["realm"]+"\" " +
		"class=\"selectw\">");

	container.appendChild(tab);
	
}

function addSipAccount_R(value){
	var container = $('td[id=sip_account_R_container]')[0];

	document.getElementById("hidSipAccountRCount").value++;
	// idx - unique block number on page, not id of transport in the database
	var idx = document.getElementById("hidSipAccountRCount").value;
	
	if(!value || value==null){
		value = {
			"id": "", 
			"accounttypeid": "",
			"tr_id": "", 
			"dialplanid": "", 
			"fullname": "", 
			"calllimit": "", 
			"name": "", 
			"secret": "", 
			"secret_mode": "", 
			"reg_host": "", 
			"reg_port": "", 
			"expire": "", 
			"realm": "", 
			"type_name": "", 
			"type_desc": "", 
			"trans_protocol": "", 
			"trans_ip": "", 
			"trans_port": "", 
			"trans_name": ""
		};
	}

	var tab = document.createElement("table");
	tab.className = "dataBlock_light";
	tab.setAttribute("type","sip_account_R");
	tab.setAttribute("idx",idx);
	tab.setAttribute("block_id",value["id"]);

	tab.onclick = function() {
		var blocks = $('table[type=sip_account_R]');
		$(blocks).each(function( index ) {
		  if(this != tab) {
			  this.className = "dataBlock_light";
			  var block_header = $('tr[type=trBlockHeader]',this)[0];
			  $(block_header).css("backgroundColor","#f5f5f5");
		  }
		  tab.className = "dataBlock_dark";
		  var block_header = $('tr[type=trBlockHeader]',tab)[0];
		  $(block_header).css("backgroundColor","#ccc");
		});
	};

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","trBlockHeader");
	var td = document.createElement("td");
	td.colSpan = 2;
	td.className = "editTableHeader";
	td.innerHTML = "<div style=\"display:inline;float:left\">&nbsp; Resource #"+idx+"&nbsp;</div>"+
	"<img class=\"imglink\" style=\"display:inline;float:right;margin-right:2px;\" onclick=\"delSipAccount(this);\" title=\"Delete Resource\" src=\"../inc/img/del.gif\">";
	tr.appendChild(td);
	tab.appendChild(tr);

	AddTableRow(tab, "id",
		"<input name=\"edResR_id_"+idx+"\" " +
		"id=\"edResR_id_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["id"]+"\" " +
		"class=\"selectw\">");

	var opstr = make_select_sip_account_types(value["accounttypeid"],"R");
	AddTableRow(tab, "accounttypeid",
		"<select name=\"edResR_accounttypeid_"+idx+"\" " +
		"id=\"edResR_accounttypeid_"+idx+"\" " +
		"class=\"selectw\">" + 
		opstr + 
		"</select>\n");

	var opstr = make_select_sip_ip_transports(value["tr_id"]);
	AddTableRow(tab, "tr_id",
		"<select name=\"edResR_tr_id_"+idx+"\" " +
		"id=\"edResR_tr_id_"+idx+"\" " +
		"class=\"selectw\">" + 
		opstr + 
		"</select>\n");

	AddTableRow(tab, "dialplanid",
		"<input name=\"edResR_dialplanid_"+idx+"\" " +
		"id=\"edResR_dialplanid_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["dialplanid"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "fullname",
		"<input name=\"edResR_fullname_"+idx+"\" " +
		"id=\"edResR_fullname_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["fullname"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "calllimit",
		"<input name=\"edResR_calllimit_"+idx+"\" " +
		"id=\"edResR_calllimit_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["calllimit"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "name",
		"<input name=\"edResR_name_"+idx+"\" " +
		"id=\"edResR_name_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["name"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "secret",
		"<input name=\"edResR_secret_"+idx+"\" " +
		"id=\"edResR_secret_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["secret"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "secret_mode",
		"<input name=\"edResR_secret_mode_"+idx+"\" " +
		"id=\"edResR_secret_mode_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["secret_mode"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "reg_host",
		"<input name=\"edResR_reg_host_"+idx+"\" " +
		"id=\"edResR_reg_host_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["reg_host"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "reg_port",
		"<input name=\"edResR_reg_port_"+idx+"\" " +
		"id=\"edResR_reg_port_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["reg_port"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "expire",
		"<input name=\"edResR_expire_"+idx+"\" " +
		"id=\"edResR_expire_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["expire"]+"\" " +
		"class=\"selectw\">");

	AddTableRow(tab, "realm",
		"<input name=\"edResR_realm_"+idx+"\" " +
		"id=\"edResR_realm_"+idx+"\" " +
		"type=\"text\" " +
		"value=\""+value["realm"]+"\" " +
		"class=\"selectw\">");

	container.appendChild(tab);
	
}

function delSipAccount(obj){
	obj.parentElement.parentElement.parentElement.remove();
	var obj_id = obj.parentElement.parentElement.parentElement.getAttribute('block_id');
	aDelAccountID.push(obj_id);
}


function onSaveClick(){

	var blocks = $('table[type=sip_account_D]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edResD_id_"+idx).value;
		var accounttypeid = document.getElementById("edResD_accounttypeid_"+idx).value;
		var tr_id = document.getElementById("edResD_tr_id_"+idx).value;
		var dialplanid = document.getElementById("edResD_dialplanid_"+idx).value;
		var fullname = document.getElementById("edResD_fullname_"+idx).value;
		var calllimit = document.getElementById("edResD_calllimit_"+idx).value;
		var name = document.getElementById("edResD_name_"+idx).value;
		var secret = document.getElementById("edResD_secret_"+idx).value;
		var secret_mode = document.getElementById("edResD_secret_mode_"+idx).value;
		var reg_host = document.getElementById("edResD_reg_host_"+idx).value;
		var reg_port = document.getElementById("edResD_reg_port_"+idx).value;
		var expire = document.getElementById("edResD_expire_"+idx).value;
		var realm = document.getElementById("edResD_realm_"+idx).value;

		if(!accounttypeid || accounttypeid==null || accounttypeid=='null') accounttypeid = "";
		if(!tr_id || tr_id==null || tr_id=='null') tr_id = "";
		if(!dialplanid || dialplanid==null || dialplanid=='null') dialplanid = "";
		if(!calllimit || calllimit==null || calllimit=='null') calllimit = "";
		if(!secret_mode || secret_mode==null || secret_mode=='null') secret_mode = "";
		if(!reg_port || reg_port==null || reg_port=='null') reg_port = "";
		if(!expire || expire==null || expire=='null') expire = "";

		save_sip_account(id,accounttypeid,tr_id,dialplanid,fullname,calllimit,name,secret,secret_mode,reg_host,reg_port,expire,realm);
	});

	var blocks = $('table[type=sip_account_R]');
	$(blocks).each(function(index,value) {
		var idx = value.getAttribute("idx");
		var id = document.getElementById("edResR_id_"+idx).value;
		var accounttypeid = document.getElementById("edResR_accounttypeid_"+idx).value;
		var tr_id = document.getElementById("edResR_tr_id_"+idx).value;
		var dialplanid = document.getElementById("edResR_dialplanid_"+idx).value;
		var fullname = document.getElementById("edResR_fullname_"+idx).value;
		var calllimit = document.getElementById("edResR_calllimit_"+idx).value;
		var name = document.getElementById("edResR_name_"+idx).value;
		var secret = document.getElementById("edResR_secret_"+idx).value;
		var secret_mode = document.getElementById("edResR_secret_mode_"+idx).value;
		var reg_host = document.getElementById("edResR_reg_host_"+idx).value;
		var reg_port = document.getElementById("edResR_reg_port_"+idx).value;
		var expire = document.getElementById("edResR_expire_"+idx).value;
		var realm = document.getElementById("edResR_realm_"+idx).value;

		if(!accounttypeid || accounttypeid==null || accounttypeid=='null') accounttypeid = "";
		if(!tr_id || tr_id==null || tr_id=='null') tr_id = "";
		if(!dialplanid || dialplanid==null || dialplanid=='null') dialplanid = "";
		if(!calllimit || calllimit==null || calllimit=='null') calllimit = "";
		if(!secret_mode || secret_mode==null || secret_mode=='null') secret_mode = "";
		if(!reg_port || reg_port==null || reg_port=='null') reg_port = "";
		if(!expire || expire==null || expire=='null') expire = "";

		save_sip_account(id,accounttypeid,tr_id,dialplanid,fullname,calllimit,name,secret,secret_mode,reg_host,reg_port,expire,realm);
	});
	
	$(aDelAccountID).each(function(index,value){
		//alert(value);
		del_sip_account(value);
	});
}

function save_sip_account(id,accounttypeid,tr_id,dialplanid,fullname,calllimit,name,secret,secret_mode,reg_host,reg_port,expire,realm){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'save_sip_account',
			id: id,
			accounttypeid: accounttypeid,
			tr_id: tr_id,
			dialplanid: dialplanid,
			fullname: fullname,
			calllimit: calllimit,
			name: name,
			secret: secret,
			secret_mode: secret_mode,
			reg_host: reg_host,
			reg_port: reg_port,
			expire: expire,
			realm: realm
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: save_sip_account');
		}
	});
}


function del_sip_account(id){
	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'del_sip_account',
			id: id
		}),
		dataType: 'json',
		async: false,
		timeout: 10000,
		success: function(data) {
		},
		error:function(){
			alert('error: del_sip_account');
		}
	});
}

