$(document).ready( function () {
	get_active_sessions();
	var ch_arch_view = document.getElementById("ch_archive_view");
	if(ch_arch_view.checked) get_archive_sessions();
});

function get_active_sessions(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_active_sessions'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['option_name']);
			$.each(data, function (index, value) {
				addActiveSessionTableRow(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_active_sessions');
		}
	});
	
	return result;
}


function get_archive_sessions(){
	var result = false;

	$.ajax({
		type: 'POST',
		url: '../com/process.php',
		data: ({
			request_name:'get_archive_sessions'
		}),
		dataType: 'json',
		async: !1,
		timeout: 10000,
		success: function(data) {
			//alert(data[0]['trans_name']);
			$.each(data, function (index, value) {
				addArchiveSessionTableRow(value);
			});
			
			result = data;
		},
		error:function(){
			alert('error: get_archive_sessions');
		}
	});
	
	return result;
}


function addActiveSessionTableRow(rowset){
	
	if(rowset['ses_type_id'] == 3)
	var tab = $('table[id=tab_active_registrations]')[0];
	else if(rowset['ses_type_id'] == 1)
	var tab = $('table[id=tab_active_calls]')[0];
	else if(rowset['ses_type_id'] == 2)
	var tab = $('table[id=tab_active_subscribes]')[0];
	
	/*var row_mode = "";
	if(!rowset || rowset==null){
		rowset = {
			"id": "", 
			"is_incoming": "", 
			"cid": "", 
			"ses_type": "", 
			"account_type": "", 
			"trans_name": "", 
			"astatus": "", 
			"fstatus": "", 
			"attr_to": "", 
			"attr_from": "", 
			"owner_user": "", 
			"from_host": "", 
			"from_port": "", 
			"expire": "", 
			"create_time": "", 
			"update_time": ""
		};
		row_mode = "";
	}*/
	if(!rowset || rowset==null) return;

	for (var key in rowset) {
		if(rowset[key]==null) rowset[key]='';
	}


	var idx = $('tr[type=sessionrow]').length;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","sessionrow");
	tr.setAttribute("row_id",idx);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.innerHTML =	idx;
	tr.appendChild(td);

	var style_1 = "infoTableCell";
	var style_2 = "infoTableCell_light";
	
	AddTableSimpleCell(tr,idx,style_1,rowset['id']);
	AddTableSimpleCell(tr,idx,style_2,rowset['is_incoming']);
	AddTableSimpleCell(tr,idx,style_1,rowset['cid']);
	//AddTableSimpleCell(tr,idx,style_2,rowset['ses_type']);
	AddTableSimpleCell(tr,idx,style_1,rowset['account_type']);
	AddTableSimpleCell(tr,idx,style_2,rowset['trans_name']);
	AddTableSimpleCell(tr,idx,style_1,rowset['astatus']);
	AddTableSimpleCell(tr,idx,style_2,rowset['fstatus']);
	AddTableSimpleCell(tr,idx,style_1,rowset['attr_to']);
	AddTableSimpleCell(tr,idx,style_2,rowset['attr_from']);
	AddTableSimpleCell(tr,idx,style_1,rowset['owner_user']);
	AddTableSimpleCell(tr,idx,style_2,rowset['from_host']);
	AddTableSimpleCell(tr,idx,style_1,rowset['from_port']);
	AddTableSimpleCell(tr,idx,style_2,rowset['expire']);
	AddTableSimpleCell(tr,idx,style_1,rowset['create_time']);
	AddTableSimpleCell(tr,idx,style_2,rowset['update_time']);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
		$('td[class=infoTableCell_light]',tr).toggleClass("infoTableCell_light_active").toggleClass("infoTableCell_light");
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
		$('td[class=infoTableCell_light_active]',tr).toggleClass("infoTableCell_light_active").toggleClass("infoTableCell_light");
    });	

	//if(row_mode == "a") $(tr).children('td').children('input').css("backgroundColor","#c4ffc4");
}


function addArchiveSessionTableRow(rowset){
	
	if(rowset['ses_type_id'] == 3)
	var tab = $('table[id=tab_archive_registrations]')[0];
	else if(rowset['ses_type_id'] == 1)
	var tab = $('table[id=tab_archive_calls]')[0];
	else if(rowset['ses_type_id'] == 2)
	var tab = $('table[id=tab_archive_subscribes]')[0];
	
	if(!rowset || rowset==null) return;

	for (var key in rowset) {
		if(rowset[key]==null) rowset[key]='';
	}


	var idx = $('tr[type=sessionrow]').length;

	var tr = document.createElement("tr");
	tr.className = "bgsel";
	tr.setAttribute("type","sessionrow");
	tr.setAttribute("row_id",idx);
	
	var td = document.createElement("td");
	td.style.display = "none";
	td.innerHTML =	idx;
	tr.appendChild(td);

	var style_1 = "infoTableCell";
	var style_2 = "infoTableCell_light";
	
	AddTableSimpleCell(tr,idx,style_1,rowset['id']);
	AddTableSimpleCell(tr,idx,style_2,rowset['is_incoming']);
	AddTableSimpleCell(tr,idx,style_1,rowset['cid']);
	AddTableSimpleCell(tr,idx,style_1,rowset['account_type']);
	AddTableSimpleCell(tr,idx,style_2,rowset['trans_name']);
	AddTableSimpleCell(tr,idx,style_1,rowset['astatus']);
	AddTableSimpleCell(tr,idx,style_2,rowset['fstatus']);
	AddTableSimpleCell(tr,idx,style_1,rowset['uri_to']);
	AddTableSimpleCell(tr,idx,style_2,rowset['uri_from']);
	AddTableSimpleCell(tr,idx,style_1,rowset['owner_user']);
	AddTableSimpleCell(tr,idx,style_2,rowset['from_host']);
	AddTableSimpleCell(tr,idx,style_1,rowset['from_port']);
	AddTableSimpleCell(tr,idx,style_2,rowset['expire']);
	AddTableSimpleCell(tr,idx,style_1,rowset['create_time']);
	AddTableSimpleCell(tr,idx,style_2,rowset['update_time']);

	tab.appendChild(tr);

	tr.addEventListener('mouseover', function () {
        tr.style.backgroundColor='#D3D3D3';
		$('td[class=infoTableCell_light]',tr).toggleClass("infoTableCell_light_active").toggleClass("infoTableCell_light");
    });
    tr.addEventListener('mouseleave', function () {
        tr.style.backgroundColor='#F5F5F5';
		$('td[class=infoTableCell_light_active]',tr).toggleClass("infoTableCell_light_active").toggleClass("infoTableCell_light");
    });	

}

function viewArchiveSessions(){
	var ch_obj = document.getElementById("ch_archive_view");
	var obj = document.getElementById("tab_archive_calls");
	if(ch_obj.checked){
		get_archive_sessions();
	} else {
		$('tr:gt(0)','table[id=tab_archive_registrations]').remove();
		$('tr:gt(0)','table[id=tab_archive_calls]').remove();
		$('tr:gt(0)','table[id=tab_archive_subscribes]').remove();
	}
	
}